'
' SemanticExpert Runtime 
'
import lang.SmallTable

public Next_Comming as boolean = false
public Back_Comming as boolean = false
public FInish_Comming as boolean = false

public reg_proc as pointer = null
public Act_Step as integer = 1

public enum ACTION_LIST
       ACTION_NEXT = 1
       ACTION_BACK = 2
       ACTION_FINISH = 3
end enum

dim hit as integer = 0
dim desicion as integer = 0

public declare sub GoFinish ()

$include "SemRTForm.class"

dim byref ExpertForm as SemRTForm

sub FinishEnabled ( byval Enabled as boolean )
    ExpertForm.BtnFinish.Enabled = Enabled
end sub


sub RelocateForm ( byref Dest as Widget, byref Src as Control )
 dim i as integer, c as integer
 dim rmc as Collection

 c = Src.GetControlCount()
 if c > 0 then
    for i = 0 to c-1
        dim byref ct as Control
        set ct = Src.GetControl ( i )
        if (ref ct <> null) and (ct.ChildClass = false) then
        rmc.add ( ct )
        end if
    next
 end if


 c = rmc.count
 if c > 0 then
    for i = 0 to c - 1
        set ct = rmc.item ( i )
           if ct.IsImplement ("Widget")  then
              dim byref w as Widget
              set w = ref ct
              w.Parent = Dest
           end if
    next
 end if

end sub

sub FormExists ( byval ClassName as string )
    dim byref ci as ClassInfo
    set ci = classes.GetClassFromName ( ClassName )
    if ref ci = null then
       msgbox "    ,   " + ClassName + "  .\n    ,        .\n,        ,       ."
       exit (1)
    end if

end sub

sub Store_Value (byval Name as string, byval Value as string )
dim tbl as SmallTable
    tbl.Open ("storevar.dat")
    if tbl.SelectWhere ("Name", Name) then
       tbl.Set ("Value", Value)
    else
       tbl.Insert (Name + " | " + Value)
    end if
    tbl.Save()
end sub

function Have_Value ( byref Control as Control, byval CtrlName as string ) as boolean
return = false
    dim byref ctrl as Control
    set ctrl = Control.GetControlByName ( CtrlName )
    if ref ctrl <> null then
       return = true
    end if
end function

function Have_ValueR ( byref Control as Control, byval CtrlName as string ) as boolean
return = false
    dim byref ctrl as Control
    set ctrl = Control.GetControlByName ( CtrlName )
    if ref ctrl <> null then
       if (ctrl.isImplement("Label") = true) or (ctrl.isImplement("Static") = true) then
       else
       return = true
       end if
    end if
end function

function Query_Value ( byref Control as Control, byval CtrlName as string ) as string
    dim byref ctrl as Control
    set ctrl = Control.GetControlByName ( CtrlName )
    if ref ctrl <> null then
       return = ctrl.Value ()
    else
       msgbox "      ,      " + CtrlName + ".     ."
    end if
end function

sub Post_Value ( byref Control as Control, byval CtrlName as string, byval Value as string )
dim tbl as SmallTable
dim sv as string = Value

    dim byref ctrl as Control


    tbl.Open ("storevar.dat")
    tbl.cursor = 1
    if tbl.SelectWhere ("Name",CtrlName) then
       sv = tbl.Get ("Value")
       'msgbox "HAVE: " + CtrlName

    end if

    set ctrl = Control.GetControlByName ( CtrlName )
    if ref ctrl <> null then
       ctrl.SetupValue (sv)
    else
       msgbox "      ,      " + CtrlName + ".     ."
    end if
end sub


sub Drop_Control ( byref ctrl as Control )

    dim i as integer, c as integer
    dim k as integer = 0

    dim byref ct as Control

    c = ctrl.GetControlCount ()
    if c > 0 then
       for i = 0 to c-1 
           set ct = ctrl.GetControl ( k )
           if ct.ChildClass = false then
           delete ct
           else
           k=k+1
           end if

       next
    end if

end sub

function WaitForAction () as integer
         do
            if Next_Comming = true then 
               return = ACTION_NEXT
               exit do
            end if
            if Back_Comming = true then 
               return = ACTION_BACK
               exit do
            end if
            if FInish_Comming = true then 
               return = ACTION_FINISH
               exit do
            end if
            doevents
         loop
         Next_Comming = false
         Back_Comming = false
         Finish_Comming = false
end function


sub Register_Action ( byval FarProc as pointer )
    reg_proc = FarProc
end sub


function  ( byval Msg as string ) as integer
    hit = 0
    msgbox Msg, ""
end function

' 
sub Start_Expert ()
    set ExpertForm = new SemRTForm ()
    ExpertForm.Show()
end sub

' 
sub Destroy_Expert ()

end sub




