'*                                                                              
'*  CONSOLE.BAS - Force Basic Module                                            
'*                                                                            
'*  Force Basic Run-Time Library Version 1.0                                  
'*                                                                              
'*  Copyright(c) 2005 by Metlashevskiy Egor. All right reserved                 
'*                                                                              
'*
'*       .
'*     DOS  Windows( )  
'*
unit Console

$ifndef __CONSOLE_BAS
$define __CONSOLE_BAS

$ifndef _CONSOLE
$error       
$error This application not support console mode
$endif

$include "console.hlp"
'
' 
'
'public declare sub print (...)
'public declare sub color (byval fore as integer, byval back as integer)
'public declare sub color (byval fore as integer)
'public declare sub locate (byval x as integer, byval y as integer)
'public declare sub cls 
'public declare function inkey$ 
'public decalre function input$ (byref s as string) 
'public declare function putch (byval _char as byte )

'
' 
'
public enum ColorsConstants
    BLACK = 0        ' Ҹ  
    BLUE = 1
    GREEN = 2
    CYAN = 3
    RED = 4
    MAGENTA = 5
    BROWN = 6
    LIGHTGRAY = 7
    DARK = 8     '   
    LIGHTBLUE = 9
    LIGHTGREEN = 10
    LIGHTCYAN = 11
    LIGHTRED = 12
    LIGHTMAGENTA = 13
    YELLOW = 14
    WHITE = 15
end enum

'
'  
'
public enum TextModes

    BW40 = 0      'DOS -  
    C40  = 1
    BW80 = 2
    C80  = 3
    MONO = 7
    C4350 = 64
    C40X14 = 8    '  
    C40X21 = 9
    C40X28 = 10
    C40X43 = 11
    C40X50 = 12
    C40X60 = 13
    C80X14 = 14
    C80X21 = 15
    C80X28 = 16
    C80X43 = 17
    C80X50 = 18
    C80X60 = 19
    BW40X14 = 20  ' - 
    BW40X21 = 21
    BW40X28 = 22
    BW40X43 = 23
    BW40X50 = 24
    BW40X60 = 25
    BW80X14 = 26
    BW80X21 = 27
    BW80X28 = 28
    BW80X43 = 29
    BW80X50 = 30
    BW80X60 = 31

    _ORIGMODE = 65 '     
end enum

'
'   
'
public sub Screen (byval Mode as long)
  asm con 8
end sub

'
'  prints     _String
'
public sub Prints (byval String as string)
  asm push dd ptr ebp+8   '    
  asm con 0               '     
end sub

'public sub Print (byval String as string)
'  asm push dd ptr ebp+8   '    
'  asm con 0               '     
'end sub

'   
public sub CPrint (byval String as string)
  asm push dd ptr ebp+8   
  asm con 9                
end sub

'
'  putch     
'
'    _Char -  
'
public sub Putch (byval Char as byte)
  asm con 7
end sub


'
'    
'
public sub Print (...)
dim i as dword
dim byref pString as string
dim byref pSmall as small
dim byref pByte as byte
dim byref pWord as word
dim byref pShort as short
dim byref pDWord as dword
dim byref pLong as long
dim byref pSingle as single
dim byref pDouble as double
dim byref pExtendet as extendet
'dim pText as string

dim argType as byte
dim pPointer as dword

  if ArgCount > 0 then
    for i = 0 to ArgCount - 1
      argType = Arguments(i).argType
      select case argType
      case tpSMALL:
        set pSmall = Arguments(i).ptr
        prints str$(pSmall)
      case tpBYTE:
        set pByte = Arguments(i).ptr
        prints str$(pByte)
      case tpWORD:
        set pWord = Arguments(i).ptr
        prints str$(pWord)
      case tpSHORT:
        set pShort = Arguments(i).ptr
        prints str$(pShort)
      case tpDWORD:
        set pDWord = Arguments(i).ptr
        prints str$(pDWord)
      case tpLONG:
        set pLong = Arguments(i).ptr
        prints str$(pLong)
      case tpSINGLE:
        set pSingle = Arguments(i).ptr
        prints str$(pSingle)
      case tpDOUBLE:
        set pDouble = Arguments(i).ptr
        prints str$(pDouble)
      case tpEXTENDET:
        set pExtendet = Arguments(i).ptr
        prints str$(pExtendet)
      case tpSTRING:
        set pString = Arguments(i).ptr
        prints pString
      case 255:
        prints "[UnknownType]"  '   
      end select
    next
  end if

end sub

' 
' : fore -  
'             back -    
'
public sub Color (byval Fore as integer,byval Back as integer)
asm
  push long ptr ebp+8
  con 1 
  push long ptr ebp+12
  con 2 
end asm
end sub

'
'   
'
public sub Color (byval Fore as integer)
  asm push long ptr ebp+8
  asm con 1 
end sub

' 
'     (x,y), 
'
'   x -  
'   y -  
'
public sub Locate (byval x as integer, byval y as integer)
  asm push long ptr ebp+8
  asm push long ptr ebp+12
  asm con 3
end sub

'
'  
'
public sub Cls 
  asm con 4
end sub

'
'  ASCII   
'
public function Inkey () as string
asm
   con 5
end asm
end function

'
'    
'
public function Input () as string
dim ret as string
asm
   con 6
end asm
   return = ret
end function

'
'        
'
public function Input (byval Prompt as string) as string
prints Prompt
dim ret as string
asm
   con 6
end asm
   return = ret
end function

private sub Console_RaiseError
   print "Run-Time Error: ", Runable.ErrDesc
   input
end sub


sub InitLibrary
  Runable.OnError = subptr (Console_RaiseError)
end sub

sub ReleaseLibrary
end sub
$endif