'*
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved.
'*
'*  Object    .   
'*  Object.
'* 
'* 
unit lang.Object

import system
import console

class Object

private:

    dim _ref as long = 0      ' -   
    dim _classname as string  '  
    dim _classsize as dword   '  
    
public:    

    public property ClassName as string
    public property ClassSize as dword
    

    '**
    '*       
    '*
    public function Ref () as pointer
        return = ref this  
    end function 
    
    '**
    '*  = (Equality) -   
    '*
    public operator = ( byref m_object as Object ) as byte
           
       if (ref this) = (ref m_object) then
          return = true
       else
          return = false   
       end if

    end function
    
    '**
    '*  = ()
    '*
    public virtual operator := ( byref m_object as Object ) as byte
        this._ref = m_object._ref
        m_object._ref = m_object._ref + 1

        'print "NOW := betwen objects ( ref1 = "+str(this._ref)+",  and ref2 = "+str(m_object._ref)+") \n"
    end function

    '**
    '*    
    '*
    '*        ,
    '*    (  new), 
    '*     . , ... 
    '*  
    virtual sub Finalize ()  
    
    end sub

    '**
    '* 
    '*
    declare sub Object ()

    '**
    '* 
    '*
    declare sub ~Object ()

end class

sub Object.Object ()

    this._classname = "Object"
    this._classsize = sizeof ( object )
    
end sub

sub Object.~Object ()

 if this._ref <= 0 then
     this.Finalize()
 else
     this._ref = this._ref - 1
 end if

end sub

function Object.ClassName () as string
  return = this._classname
end function

sub Object.ClassName ( byref m_value as string )
    this._classname = m_value
end sub

function Object.ClassSize () as dword
    return = this._classsize
end function

sub Object.ClassSize ( byref m_value as dword )
    this._classsize = m_value
end sub