'**
'*
'*  SmallTable    (    )
'*    , .      
'* ,  (  ):
'* <br>
'*  Id | sotr   | price <br>
'*  1  | Ivanov | 100$  <br>
'* <br>
'*      ,      ,
'*    .
'*

unit Lang.SmallTable

import Lang.*

$document "../../doc/SmallTable.htm"

class SmallTable: implements StringBuffer

      dim FileName as string = ""
      dim Cursor as integer = 1
 
      '   
      sub Open (byval FileName as string)
          dim f as FILE
          dim line as string
          f = fopen (filename, "r+")
          if f <> null then
            do
               line = fgets (f, 10000)
               if feof (f) then exit do
               this.add trim(line)
            loop
            this.FileName = FileName
            fclose (f)
          end if
      end sub


      '    
      sub Save ( byval FileName as string )
          dim f as FILE
          f = fopen (FileName, "w+")

          if f <> null then
           dim i as integer, c as integer
           c = this.count
           if c > 0 then 
              for i = 0 to c - 1
                  dim s as string = this.item (i)
                  fprint f, s, "\n"
              next
           end if
           fclose (f)
          end if
      end sub

      '     SmallTable.FileName
      sub Save ()
          this.save (this.FileName)
      end sub


      '  - 
      function FieldCount () as integer
          dim b as StringBuffer
          b = explode (this.item(0), "|")
          return = b.Count
      end function

      '  - 
      function RowCount () as integer
          return = this.Count - 1
      end function

      '   
      function FieldName ( byval Index as integer ) as string
          dim b as StringBuffer
          b = explode (this.Item(0), "|")
          return = b.item (Index)
      end function

      '      
      function FieldIndex ( byval Name as string ) as integer
         dim b as StringBuffer
         b = explode (this.item(0), "|")

         return = -1
         dim i as integer, c as integer
         dim g as boolean = true

         c = b.Count
         if c > 0 then
             for i = 0 to c -1 
               if g = true then 
               dim t1 as string = lcase(trim (b.item(i)))
               dim t2 as string = lcase(trim (Name))
               if t1 = t2 then 
                  return = i
                  g = false
               end if
               end if
            next
         end if
      end function

      ' true,    
      function Eof () as boolean
          return = ( this.Cursor >= this.RowCount)
      end function

      '   ,    SmallTamble.Cursor
      function Get ( byval fName as string) as string
         dim b as StringBuffer
         b = explode (this.item(this.Cursor), "|")
         return = trim ( b.item( this.FieldIndex ( fName ) ) )
      end function

      function GetStr ( byval fName as string ) as string 
         dim r as string = trim(this.Get ( fName ))
         return = r

         if mid(r,0,1) = "\'" then
            return = mid$(r,1,len(r)-2)
         end if

      end function

      'SELECT * FROM Table WHERE Field=Value
      function SelectWhere ( byval Field as string, byval Value as string ) as boolean
        return = false
        dim i as integer, c as integer
        c = this.RowCount
        this.Cursor = 1
        for i = 1 to c
        if return = false then
            if trim(this.Get (Field)) = trim(Value) then
               return = true
            end if

            if return = false then this.Cursor = this.Cursor + 1
        end if
        next
      end function


      sub Set ( byval fName as string, byval Value as string )
         dim i as integer, c as integer
         dim b as StringBuffer
         dim fi as integer = this.FieldIndex ( fName )
         dim ns as string
         b = explode (this.item(this.Cursor), "|")
         c = b.Count - 1
         for i = 0 to c 
             if i <> fi then
                ns = ns + trim(b.item (i))
             else
                ns = ns + trim(Value)
             end if
             if i <> c then
                ns = ns + " | "
             end if
         next
         this::Set ( this.Cursor, ns )
      end sub

      sub SetStr ( byval fName as string, byval Value as string )
          this.Set (fName, "\'" + Value + "\'")
      end sub

      '   <br>
      ' : SmallTable.Insert ("Ivanov | 10$ | 20.12.2006 ")
      '
      sub Insert ( byval s as string )
          this.Add (s)
          this.cursor = this.RowCount - 1
      end sub


      ' Cursor = Cursor + 1
      sub Next (): this.Cursor = this.Cursor+1: end sub

      
      '  
      sub Clear ()

         this::Clear ()

      end sub


      sub SmallTable ()
      sub SmallTable ( byval FileName as string )

end class

sub SmallTable.SmallTable ()

end sub

sub SmallTable.SmallTable ( byval FileName as string )
    this.Open ( FileName )
end sub
