'*
'*  Copyright (c) 2004-2006 by Metlashevskiy Egor. All right reserved.
'*
'*        n- ,
'*   Argument  ,    
'*     (...).
'*
'*    ,        
'*  :
'*
'*       ArgCount  -  .
'*       Arguments -    Argument.
'*                      ArgCount.
'*
'*                  
$ifndef __ARGUMENTS_BAS
$define __ARGUMENTS_BAS
$include "arguments.hlp"

'*
'*  Argument
'*
public class Argument
public:
       dim ptr as dword       '  
       dim argType as byte    ' 
       
       declare function isNumber () as boolean    
       declare function isString () as boolean
       declare function isUnknown () as boolean
       declare function GetNumber () as double
       declare function GetString () as string   
end class



function Argument.GetString () as string
dim byref pString as string
dim ret as string

 if this->argType = tpSTRING then
    set pString = this->ptr
    ret = pString
 else
    ret = ""
 end if

 return = ret
end function

function Argument.GetNumber () as double
dim byref pSmall as small
dim byref pByte as byte
dim byref pWord as word
dim byref pShort as short
dim byref pDWord as dword
dim byref pLong as long
dim byref pSingle as single
dim byref pDouble as double
dim byref pExtendet as extendet
dim p as dword
dim ret as double
dim aType as byte
      aType = this.argType
      p =  this.ptr
      select case aType
      case tpSMALL:
        set pSmall = p: ret = pSmall
      case tpBYTE:
        set pByte = p: ret = pByte
      case tpWORD:
        set pWord = p: ret = pWord
      case tpSHORT:
        set pShort = p: ret = pShort
      case tpDWORD:
        set pDWord = p: ret = pDWord
      case tpLONG:
        set pLong = p: ret = pLong
      case tpSINGLE:
        set pSingle = p: ret = pSingle
      case tpDOUBLE:
        set pDouble = p: ret = pDouble
      case tpEXTENDET:
        set pExtendet = p: ret = pExtendet
      case else:
        ret = 0
      end select
      return = ret
end function

function Argument.isNumber () as boolean
  
  if (this.argType >= 0) and (this.argType <= 8) then
      return = true
  else
      return = false
  end if

end function

function Argument.isString () as boolean

  if this->argType = tpSTRING then
     return = true
  else
     return = false 
  end if

end function
           
function Argument.isUnknown () as boolean

  if this->argType = tpUNKNOWN then
     return = true
  else
     return = false 
  end if

end function

$endif