'*                                                                            
'*  STRINGS.BAS - Force Basic Module                                            
'*                                                                              
'*  Copyright(c) 2005 by Metlashevskiy Egor. All right reserved                 
'*                                                                              
'*
'*       Basic',  
'*     .
'*
'*

$ifndef __STRINGS_BAS
$define __STRINGS_BAS

$include "system.bas"
$include "strings.hlp"

'
'   
'
function Str (byval Number as double) as string: asm sys 0: end function
function Str (byval Number as long) as string: asm sys 39: end function
function Val (byval String as string) as double: asm sys 1: end function
function Oct (byval Number as long) as string: asm sys 2: end function
function Hex (byval Number as long) as string: asm sys 3: end function
function Asc (byval String as string) as byte: asm sys 5: end function
function Chr (byval Number as byte) as string: asm sys 6: end function
function Trim (byval String as string) as string: asm sys 7: end function
function RTrim (byval String as string) as string: asm sys 8: end function
function LTrim (byval String as string) as string: asm sys 9: end function
function LCase (byval String as string) as string: asm sys 10: end function
function UCase (byval String as string) as string: asm sys 11: end function
function Left (byval String as string, byval Length as long) as string: asm sys 12: end function
function Right (byval String as string, byval Length as long) as string: asm sys 13: end function
function Mid (byval String as string, byval Start as long, byval Length as long) as string: asm sys 14: end function
function Mid (byval String as string, byval Start as long) as string: asm sys 15: end function
function Space (byval Number as long) as string: asm sys 16: end function
function Len (byval String as string) as dword: asm sys 17: end function
function InStr (byval start as integer, byval str1 as string, byval str2 as string, byval direc as integer, byval CaseSensetive as boolean) as integer: asm sys 40: end function
'**
'* StrReplace -    'ch1'   'str'   'ch2' 
'*
function StrReplace ( byval str1 as string, byval ch1 as string, byval ch2 as string ) as string
dim i as integer, c as integer
dim char as string
dim ret as string = ""
  c = Len ( str1 )
  for i = 0 to c
    char = Mid$( str1, i , len(ch1))
    if ( char = ch1 ) then
         ret = ret + ch2
         i = i + (len (ch1)-1)
    else
         ret = ret + mid(char,0,1)
    end if
  next
  return = ret
end function   


'
'       (  C++)
'
sub MemCpy (byval Destination as pointer, byval Source as pointer, byval Size as dword): asm sys 18: end sub
function MemCmp (byval Mem1 as pointer, byval Mem2 as pointer, byval Size as dword) as integer: asm sys 19: end function
sub MemSet (byval Destination as pointer, byval Value as byte, byval Size as dword): asm sys 20: end sub
sub StrCpy (byval Dest as pointer, byval Src as string): asm sys 26: end sub
function StrCmp (byval Dest as pointer, byval Src as pointer) as integer: asm sys 27: end function
sub StrCat (byval Dest as pointer, byval Src as pointer): asm sys 28: end sub
sub StrLwr (byval Src as pointer): asm sys 29: end sub
sub StrUpr (byval Src as pointer): asm sys 30: end sub
function StrColl (byval Dest as pointer, byval Src as pointer) as integer: asm sys 31: end function
function StrLen (byval Src as pointer) as dword: asm sys 32: end function
function StrICmp (byval Dest as pointer, byval Src as pointer) as integer: asm sys 33: end function
function StrIColl (byval Dest as pointer, byval Src as pointer) as integer: asm sys 34: end function
function CharToStr (byval Src as pointer) as string: asm sys 35: end function
sub StrCpy (byval Dest as pointer, byval Src as pointer): asm sys 36: end sub
sub StrCat (byval Dest as pointer, byval Src as string): asm sys 37: end sub

$endif