'*                                                    
'* CustomComboBox Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.CustomComboBox

$document "../../../doc/CustomComboBox.htm"

import windows.gui.Widget

published class CustomComboBox: implements Widget ()

published:

      event OnChange ()

public:
      '**
      '*     CustomComboBox
      '*

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean)
      end sub

      '**
      '*    
      '*
      sub AddItem ( byval m_string as string )
          dim a as AnsiString (m_string)
          SendMessage ( this.hWnd, CB_ADDSTRING, 0, AddressOf(a.data))
      end sub

      '**
      '*  
      '*
      sub DeleteItem ( byval Index as integer )
          SendMessage ( this.hWnd, CB_DELETESTRING, Index, 0)
      end sub

      '**
      '*  -   
      '*
      function ListCount () as integer
          return = SendMessage ( this.hWnd, CB_GETCOUNT, 0, 0)
      end function


      '**
      '*   
      '*
      sub Clear ()

          dim i as integer, c as integer
          c = this.ListCount
          for i = 0 to c - 1
              this.DeleteItem (0)
          next

      end sub

      '**
      '*    
      '*
      function ListIndex () as integer
          return = SendMessage ( this.hWnd, CB_GETCURSEL, 0, 0)
      end function


      sub CustomComboBox ()


end class

'def events
private sub Combo_OnChange ( byref c as CustomComboBox ): end sub


sub CustomComboBox.CustomComboBox ()
    this.OnChange = subptr ( Combo_OnChange )
end sub




