'*                                                    
'* Edit Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Edit

$document "../../../doc/Edit.htm"

import windows.gui.CustomEdit

published class Edit: implements CustomEdit

      declare sub Initialize ()

      sub Edit ( byref Widget as Widget )

      virtual function Value () as string
              return = this.Caption
      end function
      virtual sub SetupValue ( byval m_Value as string )
              this.Caption = m_Value
      end sub

end class

sub Edit.Initialize ()
    this.Caption = "Edit"
    this.BorderStyle = bsSingle
    'this.AddWndExStyle WS_EX_CLIENTEDGE
end sub


sub Edit.Edit ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Edit", WS_CHILD or WS_TABSTOP or ES_WANTRETURN or ES_NOHIDESEL or ES_AUTOHSCROLL, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub

sub InitLibrary

    RegisterClass ( "Edit", subptrclass ( Edit, Edit ) )

end sub

