'*                                                    
'* Image Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Image

$document "../../../doc/Image.htm"

import windows.gui.Control

public class Picture: implements Object

    private m_handle as pointer = null
    private m_type as integer


    function Handle () as long
        return = m_handle
    end function

    function ImageType () as long
        return = m_type
    end function


    sub LoadImage ( byval FileName as string )
        m_handle = LoadImage(GetModuleHandle(0), FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE)
        m_type = IMAGE_BITMAP
    end sub


end class


published class Image: implements Widget ()

   private m_filename as string
   public Picture as Picture

published:

   property FileName as string

public:
      declare sub Initialize ()

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
        if message = WM_SIZE then

        end if
      end sub


      sub Image ( byref Widget as Widget )


end class

sub Image.FileName ( byref FileName as string )
    this.Picture.LoadImage ( FileName )
    this.m_FileName = FileName

    if this.Picture.Handle <> null then
       SendMessage this.hWnd, STM_SETIMAGE ,this.Picture.ImageType, this.Picture.Handle
       this.Refresh()
    end if
end sub

function Image.FileName () as string
    return = this.m_FileName
end function

sub Image.Initialize ()
    this.Caption = "Image"
end sub

sub Image.Image ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Static", WS_CHILD or WS_TABSTOP or SS_BITMAP, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub

sub InitLibrary

    RegisterClass ( "Image", subptrclass ( Image, Image ) )

end sub


