'*                                                    
'* Memo Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Memo

$document "../../../doc/Memo.htm"

import windows.gui.CustomEdit

$include "commctrl.inc"

published class Memo: implements CustomEdit

      sub Memo ( byref Widget as Widget )

      private sub Initialize ()
          dim exStyle as long
          this.Caption = "Memo"
          exStyle = this.GetWndExStyle ()
          exStyle = exStyle or WS_EX_CLIENTEDGE 
          this.SetWndExStyle ( exStyle )
      end sub

      virtual function Value () as string
              return = this.Caption
      end function
      virtual sub SetupValue ( byval m_Value as string )
              this.Caption = m_Value
      end sub

end class


sub Memo.Memo ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Edit", WS_CHILD or TBSTYLE_TOOLTIPS or WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or _
                                 ES_AUTOVSCROLL or ES_AUTOHSCROLL or WS_HSCROLL or WS_VSCROLL, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub


sub InitLibrary

    RegisterClass ( "Memo", subptrclass ( Memo, Memo ) )

end sub


