'*
'* Button Class
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.RadioButton

$document "../../../doc/RadioButton.htm"

import windows.gui.CustomButton

published class RadioButton: implements CustomButton

      sub RadioButton ( byref Widget as Widget )

      sub Initialize ()
          this.Caption = "RadioButton"
      end sub

      virtual function Value () as string
              return = str ( this.Checked )
      end function

      virtual sub SetupValue ( byval m_Value as string )
              this.Checked = val ( m_Value )
      end sub


public:
      '**
      '* ⥫ ࠡ稪 ᮡ⨩  RadioButton
      '*
      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )

         if (message = WM_LBUTTONDOWN) or (message = WM_RBUTTONDOWN) or (message = WM_MBUTTONDOWN) then
               if this.IsDesigning then

                  dim i as integer, c as integer
                  dim byref par as Control
                  set par = this.GetParentClass ()
                  if ref par <> null then
                     c = par.GetControlCount()

                     for i = 0 to c - 1

                         dim byref ct as Control
                         set ct = par.GetControl (i)
                         if ct.IsImplement ("RadioButton") then

                            dim byref rb as RadioButton
                            set rb = ref ct
                            if ref rb <> ref this then

                               rb.Checked = BST_UNCHECKED

                            end if
                         end if

                     next

                  end if

               end if

         end if

      end sub


end class

sub RadioButton.RadioButton ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Button", WS_CHILD or BS_AUTORADIOBUTTON, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()

end sub

sub InitLibrary

    RegisterClass ( "RadioButton", subptrclass ( RadioButton, RadioButton ) )

end sub

