'*                                                    
'* RichEdit -                                           
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.RichEdit

$document "../../../doc/RichEdit.htm"

import windows.gui.CustomEdit
import windows.Library

published class RichEdit: implements CustomEdit

      declare sub Initialize ()



      sub RichEdit ( byref Widget as Widget )

end class

sub RichEdit.Initialize ()
    this.Caption = "RichEdit"
    this.BorderStyle = bsSingle
    this.AddWndExStyle (WS_EX_NOPARENTNOTIFY)
    'this.AddWndExStyle (WS_EX_CONTROLPARENT)
end sub


sub RichEdit.RichEdit ( byref Widget as Widget )
dim pwnd as long = null+1
if (ref Widget) <> null then pwnd = Widget.hWnd

    this.CreateControl ( "RichEdit", WS_CHILD or WS_TABSTOP or WS_VSCROLL or _
                                     ES_MULTILINE or ES_AUTOHSCROLL or ES_AUTOVSCROLL , 10, 10, 90, 30, pwnd )
    this.Initialize()
end sub


private hLib as pointer

sub InitLibrary

    RegisterClass ( "RichEdit", subptrclass ( RichEdit, RichEdit ) )


    hlib = LoadLibrary ("Riched32.dll")

end sub

sub ReleaseLibrary

    FreeLibrary ( hLib )

end sub



