'//====== COMMON CONTROL STYLES ================================================


'$define CCS_TOP                 0x00000001
'$define CCS_NOMOVEY             0x00000002
'$define CCS_BOTTOM              0x00000003
'$define CCS_NORESIZE            0x00000004
'$define CCS_NOPARENTALIGN       0x00000008
'$define CCS_ADJUSTABLE          0x00000020
'$define CCS_NODIVIDER           0x00000040
'$define CCS_VERT                0x00000080
'$define CCS_LEFT                (CCS_VERT or CCS_TOP)
'$define CCS_RIGHT               (CCS_VERT or CCS_BOTTOM)
'$define CCS_NOMOVEX             (CCS_VERT or CCS_NOMOVEY)
'$define SBARS_SIZEGRIP  0x0100
'$define SB_SETPARTS             (WM_USER+4)
'$define SB_GETPARTS             (WM_USER+6)
'$define SB_GETBORDERS           (WM_USER+7)
'$define SB_SETMINHEIGHT         (WM_USER+8)
'$define SB_SIMPLE               (WM_USER+9)
'$define SB_GETRECT              (WM_USER+10)
'$define SB_SETTEXT              (WM_USER+1)
'$define SB_GETTEXT              (WM_USER+2)
'$define SB_GETTEXTLENGTH        (WM_USER+3)


$define HOTKEY_CLASSA	"msctls_hotkey32"
$define PROGRESS_CLASSA	"msctls_progress32"
$define STATUSCLASSNAMEA	"msctls_statusbar32"
$define TOOLBARCLASSNAMEA	"ToolbarWindow32"
$define TOOLTIPS_CLASSA	"tooltips_class32"
$define TRACKBAR_CLASSA	"msctls_trackbar32"
$define UPDOWN_CLASSA	"msctls_updown32"
$define ANIMATE_CLASSA	"SysAnimate32"
$define DATETIMEPICK_CLASSA "SysDateTimePick32"
$define MONTHCAL_CLASSA "SysMonthCal32"
$define REBARCLASSNAMEA "ReBarWindow32"
$define WC_COMBOBOXEXA	"ComboBoxEx32"
$define WC_IPADDRESSA	"SysIPAddress32"
$define WC_LISTVIEWA	"SysListView32"
$define WC_TABCONTROLA	"SysTabControl32"
$define WC_TREEVIEWA	"SysTreeView32"
$define WC_HEADERA	"SysHeader32"
$define WC_PAGESCROLLERA	"SysPager"
$define WC_NATIVEFONTCTLA	"NativeFontCtl"
$define WC_BUTTONA	"Button"
$define WC_STATICA	"Static"
$define WC_EDITA	"Edit"
$define WC_LISTBOXA	"ListBox"
$define WC_COMBOBOXA	"ComboBox"
$define WC_SCROLLBARA	"ScrollBar"

$define ANIMATE_CLASS ANIMATE_CLASSA
$define HOTKEY_CLASS HOTKEY_CLASSA
$define PROGRESS_CLASS PROGRESS_CLASSA
$define STATUSCLASSNAME STATUSCLASSNAMEA
$define TOOLBARCLASSNAME TOOLBARCLASSNAMEA
$define TOOLTIPS_CLASS TOOLTIPS_CLASSA
$define TRACKBAR_CLASS TRACKBAR_CLASSA
$define UPDOWN_CLASS UPDOWN_CLASSA
$define DATETIMEPICK_CLASS DATETIMEPICK_CLASSA
$define MONTHCAL_CLASS MONTHCAL_CLASSA
$define REBARCLASSNAME REBARCLASSNAMEA
$define WC_COMBOBOXEX WC_COMBOBOXEXA
$define WC_HEADER WC_HEADERA
$define WC_IPADDRESS WC_IPADDRESSA
$define WC_LISTVIEW WC_LISTVIEWA
$define WC_TABCONTROL WC_TABCONTROLA
$define WC_TREEVIEW WC_TREEVIEWA
$define WC_PAGESCROLLER WC_PAGESCROLLERA
$define WC_NATIVEFONTCTL WC_NATIVEFONTCTLA
$define WC_BUTTON WC_BUTTONA
$define WC_STATIC WC_STATICA
$define WC_EDIT WC_EDITA
$define WC_LISTBOX WC_LISTBOXA
$define WC_COMBOBOX WC_COMBOBOXA
$define WC_SCROLLBAR WC_SCROLLBARA

$define LVM_FIRST &h1000
$define TV_FIRST &h1100
$define HDM_FIRST &h1200
$define ACM_OPEN	(WM_USER+100)
$define ACM_PLAY	(WM_USER+101)
$define ACM_STOP	(WM_USER+102)
$define ACN_START	1
$define ACN_STOP	2
$define CBEIF_TEXT	&h00000001
$define CBEIF_IMAGE	&h00000002
$define CBEIF_SELECTEDIMAGE	&h00000004
$define CBEIF_OVERLAY	&h00000008
$define CBEIF_INDENT	&h00000010
$define CBEIF_LPARAM	&h00000020
$define CBEIF_DI_SETITEM	&h10000000
$define CBEN_INSERTITEM	(CBEN_FIRST - 1)
$define CBEN_DELETEITEM	(CBEN_FIRST - 2)
$define CBEN_BEGINEDIT	(CBEN_FIRST - 4)
$define CBEN_ENDEDIT	(CBEN_FIRST - 5)
$define CBENF_KILLFOCUS	1
$define CBENF_RETURN	2
$define CBENF_ESCAPE	3
$define CBENF_DROPDOWN	4
$define CBEMAXSTRLEN 260
$define DL_BEGINDRAG	1157
$define DL_CANCELDRAG	1160
$define DL_DRAGGING	1158
$define DL_DROPPED	1159
$define DL_CURSORSET	0
$define DL_STOPCURSOR	1
$define DL_COPYCURSOR	2
$define DL_MOVECURSOR	3
$define CCS_TOP	1
$define CCS_NOMOVEY	2
$define CCS_BOTTOM	3
$define CCS_NORESIZE	4
$define CCS_NOPARENTALIGN	8
$define CCS_ADJUSTABLE	32
$define CCS_NODIVIDER	64
$define CCS_VERT 128
$define CCS_LEFT 129
$define CCS_NOMOVEX 130
$define CCS_RIGHT 131
$define ACS_CENTER	&h0001
$define ACS_TRANSPARENT	&h0002
$define ACS_AUTOPLAY	&h0004
$define ACS_TIMER	&h0008
$define PGS_VERT	&h00000000
$define PGS_HORZ	&h00000001
$define PGS_AUTOSCROLL	&h00000002
$define PGS_DRAGNDROP	&h00000004
$define CMB_MASKED	2
$define MINSYSCOMMAND	SC_SIZE
$define SBT_OWNERDRAW	&h1000
$define SBT_NOBORDERS	256
$define SBT_POPOUT	512
$define SBT_RTLREADING	1024
$define SB_SETTEXT	(WM_USER+1)
$define SB_GETTEXT	(WM_USER+2)
$define SB_GETTEXTLENGTH	(WM_USER+3)
$define SB_SETPARTS	(WM_USER+4)
$define SB_GETPARTS	(WM_USER+6)
$define SB_GETBORDERS	(WM_USER+7)
$define SB_SETMINHEIGHT	(WM_USER+8)
$define SB_SIMPLE	(WM_USER+9)
$define SB_GETRECT	(WM_USER+10)
$define MSGF_COMMCTRL_BEGINDRAG	&h4200
$define MSGF_COMMCTRL_SIZEHEADER	&h4201
$define MSGF_COMMCTRL_DRAGSELECT	&h4202
$define MSGF_COMMCTRL_TOOLBARCUST	&h4203
$define ILC_COLOR 0
$define ILC_COLOR4 4
$define ILC_COLOR8 8
$define ILC_COLOR16 16
$define ILC_COLOR24 24
$define ILC_COLOR32 32
$define ILC_COLORDDB 254
$define ILC_MASK 1
$define ILC_PALETTE 2048
$define ILCF_MOVE 0
$define ILCF_SWAP 1
$define ILS_NORMAL 0
$define ILS_GLOW 1
$define ILS_SHADOW 2
$define ILS_SATURATE 4
$define ILS_ALPHA 8
$define ILD_BLEND25 2
$define ILD_BLEND50 4
$define ILD_SELECTED 4
$define ILD_BLEND 4
$define ILD_FOCUS 2
$define ILD_MASK 16
$define ILD_NORMAL 0
$define ILD_TRANSPARENT 1
$define ILD_IMAGE &h0020
$define ILD_ROP &h0040
$define ILD_OVERLAYMASK &h0F00
$define ILD_PRESERVEALPHA &h1000
$define ILD_SCALE &h2000
$define ILD_DPISCALE &h4000
$define HDS_HORZ	0
$define HDS_BUTTONS	2
$define HDS_HIDDEN	8
$define HDS_HOTTRACK	4
$define HDS_DRAGDROP	&h0040
$define HDS_FULLDRAG	&h0080
$define HDS_FILTERBAR	&h0100
$define NM_FIRST	0
$define NM_LAST	(-99)
$define LVN_FIRST	(-100)
$define LVN_LAST	(-199)
$define HDN_FIRST	(-300)
$define HDN_LAST	(-399)
$define TVN_FIRST	(-400)
$define TVN_LAST	(-499)
$define TTN_FIRST	(-520)
$define TTN_LAST	(-549)
$define TCN_FIRST	(-550)
$define TCN_LAST	(-580)
#ifndef CDN_FIRST
$define CDN_FIRST	(-601)
$define CDN_LAST	(-699)
#endif
$define TBN_FIRST	(-700)
$define TBN_LAST	(-720)
$define UDN_FIRST	(-721)
$define UDN_LAST	(-740)
$define RBN_FIRST	(-831)
$define RBN_LAST	(-859)
$define MCN_FIRST	(-750)
$define MCN_LAST	(-759)
$define DTN_FIRST	(-760)
$define DTN_LAST	(-799)
$define CBEN_FIRST	(-800)
$define CBEN_LAST	(-830)
$define IPN_FIRST	(-860)
$define IPN_LAST	(-879)
$define IPN_FIELDCHANGED	(IPN_FIRST-0)
$define SBN_FIRST	(-880)
$define SBN_LAST	(-899)
$define PGN_FIRST	(-900)
$define PGN_LAST	(-950)
$define PGN_SCROLL	(PGN_FIRST-1)
$define PGN_CALCSIZE	(PGN_FIRST-2)
$define HDI_WIDTH	1
$define HDI_HEIGHT	1
$define HDI_TEXT	2
$define HDI_FORMAT	4
$define HDI_LPARAM	8
$define HDI_BITMAP	16
$define HDI_IMAGE	32
$define HDI_DI_SETITEM	64
$define HDI_ORDER	128
$define CBES_EX_NOEDITIMAGE	&h00000001
$define CBES_EX_NOEDITIMAGEINDENT	&h00000002
$define CBES_EX_PATHWORDBREAKPROC	&h00000004
$define CBES_EX_NOSIZELIMIT	&h00000008
$define CBES_EX_CASESENSITIVE	&h00000010
$define CBEN_GETDISPINFO	(CBEN_FIRST - 0)
$define CBEN_DRAGBEGIN	(CBEN_FIRST - 8)
$define HDI_FILTER	256
$define HDF_LEFT	0
$define HDF_RIGHT	1
$define HDF_CENTER	2
$define HDF_JUSTIFYMASK	3
$define HDF_RTLREADING	4
$define HDF_OWNERDRAW	&h8000
$define HDF_STRING	&h4000
$define HDF_BITMAP	&h2000
$define HDF_BITMAP_ON_RIGHT	&h1000
$define HDF_IMAGE	&h0800
$define HDM_GETITEMCOUNT	HDM_FIRST
$define HDM_INSERTITEM	(HDM_FIRST+1)
$define HDM_DELETEITEM	(HDM_FIRST+2)
$define HDM_GETITEM	(HDM_FIRST+3)
$define HDM_SETITEM	(HDM_FIRST+4)
$define HDM_LAYOUT	(HDM_FIRST+5)
$define HDM_GETITEMRECT (HDM_FIRST+7)
$define HDM_SETIMAGELIST	(HDM_FIRST+8)
$define HDM_GETIMAGELIST	(HDM_FIRST+9)
$define HDM_ORDERTOINDEX	(HDM_FIRST+15)
$define HDM_CREATEDRAGIMAGE	(HDM_FIRST+16)
$define HDM_GETORDERARRAY	(HDM_FIRST+17)
$define HDM_SETORDERARRAY	(HDM_FIRST+18)
$define HDM_SETHOTDIVIDER	(HDM_FIRST+19)
$define HDM_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT
$define HDM_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define HHT_NOWHERE	1
$define HHT_ONHEADER	2
$define HHT_ONDIVIDER	4
$define HHT_ONDIVOPEN	8
$define HHT_ABOVE	256
$define HHT_BELOW	512
$define HHT_TORIGHT	1024
$define HHT_TOLEFT	2048
$define HDM_HITTEST	(HDM_FIRST+6)
$define HDN_ITEMCHANGING	(HDN_FIRST-0)
$define HDN_ITEMCHANGED	(HDN_FIRST-1)
$define HDN_ITEMCLICK	(HDN_FIRST-2)
$define HDN_ITEMDBLCLICK	(HDN_FIRST-3)
$define HDN_DIVIDERDBLCLICK	(HDN_FIRST-5)
$define HDN_BEGINTRACK	(HDN_FIRST-6)
$define HDN_ENDTRACK	(HDN_FIRST-7)
$define HDN_TRACK	(HDN_FIRST-8)
$define HDN_ENDDRAG	(HDN_FIRST-11)
$define HDN_BEGINDRAG	(HDN_FIRST-10)
$define HDN_GETDISPINFO (HDN_FIRST-9)
$define HICF_OTHER &h00
$define HICF_MOUSE &h01
$define HICF_ARROWKEYS &h02
$define HICF_ACCELERATOR &h04
$define HICF_DUPACCEL &h08
$define HICF_ENTERING &h10
$define HICF_LEAVING &h20
$define HICF_RESELECT &h40
$define HICF_LMOUSE &h80
$define HICF_TOGGLEDROPDOWN &h100
$define IPM_CLEARADDRESS	(WM_USER+100)
$define IPM_SETADDRESS	(WM_USER+101)
$define IPM_GETADDRESS	(WM_USER+102)
$define IPM_SETRANGE	(WM_USER+103)
$define IPM_SETFOCUS	(WM_USER+104)
$define IPM_ISBLANK	(WM_USER+105)
$define I_INDENTCALLBACK (-1)
$define I_IMAGENONE (-2)
$define TBSTATE_CHECKED	1
$define TBSTATE_PRESSED	2
$define TBSTATE_ENABLED	4
$define TBSTATE_HIDDEN	8
$define TBSTATE_INDETERMINATE	16
$define TBSTATE_WRAP	32
$define TBSTATE_MARKED	&h0080
$define TBSTYLE_BUTTON	0
$define TBSTYLE_SEP	1
$define TBSTYLE_CHECK	2
$define TBSTYLE_GROUP	4
$define TBSTYLE_CHECKGROUP	(TBSTYLE_GROUP or TBSTYLE_CHECK)
$define TBSTYLE_DROPDOWN	8
$define TBSTYLE_AUTOSIZE	16
$define TBSTYLE_NOPREFIX	32
$define TBSTYLE_TOOLTIPS	256
$define TBSTYLE_WRAPABLE	512
$define TBSTYLE_ALTDRAG	1024
$define TBSTYLE_FLAT 2048
$define TBSTYLE_LIST 4096
$define TBSTYLE_CUSTOMERASE 8192
$define TBSTYLE_REGISTERDROP	&h4000
$define TBSTYLE_TRANSPARENT	&h8000
$define TBSTYLE_EX_DRAWDDARROWS	&h00000001
$define TBSTYLE_EX_MIXEDBUTTONS 8
$define TBSTYLE_EX_HIDECLIPPEDBUTTONS 16
$define TBSTYLE_EX_DOUBLEBUFFER	&h80
$define BTNS_BUTTON	TBSTYLE_BUTTON
$define BTNS_SEP	TBSTYLE_SEP
$define BTNS_CHECK	TBSTYLE_CHECK
$define BTNS_GROUP	TBSTYLE_GROUP
$define BTNS_CHECKGROUP	TBSTYLE_CHECKGROUP
$define BTNS_DROPDOWN	TBSTYLE_DROPDOWN
$define BTNS_AUTOSIZE	TBSTYLE_AUTOSIZE
$define BTNS_NOPREFIX	TBSTYLE_NOPREFIX
$define BTNS_WHOLEDROPDOWN	&h0080
$define BTNS_SHOWTEXT	&h0040
$define TBCDRF_NOEDGES	&h10000
$define TBCDRF_HILITEHOTTRACK	&h20000
$define TBCDRF_NOOFFSET	&h40000
$define TBCDRF_NOMARK	&h80000
$define TBCDRF_NOETCHEDEFFECT	&h100000
$define HINST_COMMCTRL	(-1)
$define IDB_STD_SMALL_COLOR	0
$define IDB_STD_LARGE_COLOR	1
$define IDB_VIEW_SMALL_COLOR	4
$define IDB_VIEW_LARGE_COLOR	5
$define IDB_HIST_SMALL_COLOR	8
$define IDB_HIST_LARGE_COLOR	9
$define STD_CUT	0
$define STD_COPY	1
$define STD_PASTE	2
$define STD_UNDO	3
$define STD_REDOW	4
$define STD_DELETE	5
$define STD_FILENEW	6
$define STD_FILEOPEN	7
$define STD_FILESAVE	8
$define STD_PRINTPRE	9
$define STD_PROPERTIES	10
$define STD_HELP	11
$define STD_FIND	12
$define STD_REPLACE	13
$define STD_PRINT	14
$define VIEW_LARGEICONS	0
$define VIEW_SMALLICONS	1
$define VIEW_LIST	2
$define VIEW_DETAILS	3
$define VIEW_SORTNAME	4
$define VIEW_SORTSIZE	5
$define VIEW_SORTDATE	6
$define VIEW_SORTTYPE	7
$define VIEW_PARENTFOLDER	8
$define VIEW_NETCONNECT	9
$define VIEW_NETDISCONNECT	10
$define VIEW_NEWFOLDER	11
$define TB_ENABLEBUTTON	(WM_USER+1)
$define TB_CHECKBUTTON	(WM_USER+2)
$define TB_PRESSBUTTON	(WM_USER+3)
$define TB_HIDEBUTTON	(WM_USER+4)
$define TB_INDETERMINATE	(WM_USER+5)
$define TB_ISBUTTONENABLED	(WM_USER+9)
$define TB_ISBUTTONCHECKED	(WM_USER+10)
$define TB_ISBUTTONPRESSED	(WM_USER+11)
$define TB_ISBUTTONHIDDEN	(WM_USER+12)
$define TB_ISBUTTONINDETERMINATE	(WM_USER+13)
$define TB_ISBUTTONHIGHLIGHTED	(WM_USER+14)
$define TB_SETSTATE	(WM_USER+17)
$define TB_GETSTATE	(WM_USER+18)
$define TB_ADDBITMAP	(WM_USER+19)
$define TB_ADDBUTTONS	(WM_USER+20)
$define TB_INSERTBUTTON	(WM_USER+21)
$define TB_DELETEBUTTON	(WM_USER+22)
$define TB_GETBUTTON	(WM_USER+23)
$define TB_BUTTONCOUNT	(WM_USER+24)
$define TB_COMMANDTOINDEX	(WM_USER+25)
$define TB_SAVERESTORE	(WM_USER+26)
$define TB_CUSTOMIZE	(WM_USER+27)
$define TB_ADDSTRING	(WM_USER+28)
$define TB_GETITEMRECT	(WM_USER+29)
$define TB_BUTTONSTRUCTSIZE	(WM_USER+30)
$define TB_SETBUTTONSIZE	(WM_USER+31)
$define TB_SETBITMAPSIZE	(WM_USER+32)
$define TB_AUTOSIZE	(WM_USER+33)
$define TB_GETTOOLTIPS	(WM_USER+35)
$define TB_SETTOOLTIPS	(WM_USER+36)
$define TB_SETPARENT	(WM_USER+37)
$define TB_SETROWS	(WM_USER+39)
$define TB_GETROWS	(WM_USER+40)
$define TB_GETBITMAPFLAGS	(WM_USER+41)
$define TB_SETCMDID	(WM_USER+42)
$define TB_CHANGEBITMAP	(WM_USER+43)
$define TB_GETBITMAP	(WM_USER+44)
$define TB_GETBUTTONTEXT	(WM_USER+45)
$define TB_REPLACEBITMAP	(WM_USER+46)
$define TB_GETBUTTONSIZE	(WM_USER+58)
$define TB_SETBUTTONWIDTH	(WM_USER+59)
$define TB_SETINDENT	(WM_USER+47)
$define TB_SETIMAGELIST	(WM_USER+48)
$define TB_GETIMAGELIST	(WM_USER+49)
$define TB_LOADIMAGES	(WM_USER+50)
$define TB_GETRECT	(WM_USER+51)
$define TB_SETHOTIMAGELIST	(WM_USER+52)
$define TB_GETHOTIMAGELIST	(WM_USER+53)
$define TB_SETDISABLEDIMAGELIST (WM_USER+54)
$define TB_GETDISABLEDIMAGELIST	(WM_USER+55)
$define TB_SETSTYLE	(WM_USER+56)
$define TB_GETSTYLE	(WM_USER+57)
$define TB_SETMAXTEXTROWS	(WM_USER+60)
$define TB_GETTEXTROWS	(WM_USER+61)
$define TB_GETOBJECT	(WM_USER+62)
$define TB_GETBUTTONINFO	(WM_USER+65)
$define TB_SETBUTTONINFO	(WM_USER+66)
$define TB_HITTEST	(WM_USER+69)
$define TB_SETEXTENDEDSTYLE	(WM_USER+84)
$define TB_GETEXTENDEDSTYLE	(WM_USER+85)
$define TB_SETDRAWTEXTFLAGS	(WM_USER+70)
$define TB_GETHOTITEM	(WM_USER+71)
$define TB_SETHOTITEM	(WM_USER+72)
$define TB_SETANCHORHIGHLIGHT	(WM_USER+73)
$define TB_GETANCHORHIGHLIGHT	(WM_USER+74)
$define TB_MAPACCELERATOR	(WM_USER+78)
$define TB_GETINSERTMARK	(WM_USER+79)
$define TB_SETINSERTMARK	(WM_USER+80)
$define TB_INSERTMARKHITTEST	(WM_USER+81)
$define TB_MOVEBUTTON		(WM_USER+82)
$define TB_GETMAXSIZE		(WM_USER+83)
$define TB_GETPADDING		(WM_USER+86)
$define TB_SETPADDING		(WM_USER+87)
$define TB_SETINSERTMARKCOLOR	(WM_USER+88)
$define TB_GETINSERTMARKCOLOR	(WM_USER+89)
$define TB_MAPACCELERATORW	(WM_USER+90)
$define TB_SETCOLORSCHEME	CCM_SETCOLORSCHEME
$define TB_GETCOLORSCHEME	CCM_GETCOLORSCHEME
$define TB_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define TB_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT
$define TBBF_LARGE 1
$define TBN_GETBUTTONINFO	(TBN_FIRST-0)
$define TBN_BEGINDRAG	(TBN_FIRST-1)
$define TBN_ENDDRAG	(TBN_FIRST-2)
$define TBN_BEGINADJUST	(TBN_FIRST-3)
$define TBN_ENDADJUST	(TBN_FIRST-4)
$define TBN_RESET	(TBN_FIRST-5)
$define TBN_QUERYINSERT	(TBN_FIRST-6)
$define TBN_QUERYDELETE	(TBN_FIRST-7)
$define TBN_TOOLBARCHANGE	(TBN_FIRST-8)
$define TBN_CUSTHELP	(TBN_FIRST-9)
$define TBN_DROPDOWN	(TBN_FIRST-10)
$define TBN_HOTITEMCHANGE	(TBN_FIRST-13)
$define TBN_DRAGOUT	(TBN_FIRST-14)
$define TBN_DELETINGBUTTON	(TBN_FIRST-15)
$define TBN_GETDISPINFO	(TBN_FIRST-16)
$define TBN_GETINFOTIP	(TBN_FIRST-18)
$define TBN_GETBUTTONINFOW	(TBN_FIRST-20)
$define TBN_RESTORE	(TBN_FIRST-21)
$define TBN_SAVE	(TBN_FIRST-22)
$define TBN_INITCUSTOMIZE	(TBN_FIRST-23)
$define TBNRF_HIDEHELP	1
$define TBNRF_ENDCUSTOMIZE	2
$define TBNF_IMAGE	1
$define TBNF_TEXT	2
$define TBNF_DI_SETITEM	&h10000000
$define TTS_ALWAYSTIP	1
$define TTS_NOPREFIX	2
$define TTS_NOANIMATE	&h10
$define TTS_NOFADE	&h20
$define TTS_BALLOON	&h40
$define TTS_CLOSE	&h80
$define TTF_IDISHWND	1
$define TTF_CENTERTIP	2
$define TTF_RTLREADING	4
$define TTF_SUBCLASS	16
$define TTF_TRACK &h0020
$define TTF_ABSOLUTE &h0080
$define TTF_TRANSPARENT &h0100
$define TTF_PARSELINKS &h1000
$define TTF_DI_SETITEM &h8000
$define TBCD_TICS 1
$define TBCD_THUMB 2
$define TBCD_CHANNEL 3
$define TBDDRET_DEFAULT 0
$define TBDDRET_NODEFAULT 1
$define TBDDRET_TREATPRESSED 2
$define TBIMHT_AFTER 1
$define TBIMHT_BACKGROUND 2
$define TTDT_AUTOMATIC	0
$define TTDT_RESHOW	1
$define TTDT_AUTOPOP	2
$define TTDT_INITIAL	3
$define TTM_ACTIVATE	(WM_USER+1)
$define TTM_SETDELAYTIME	(WM_USER+3)
$define TTM_ADDTOOL	(WM_USER+4)
$define TTM_DELTOOL	(WM_USER+5)
$define TTM_NEWTOOLRECT	(WM_USER+6)
$define TTM_RELAYEVENT	(WM_USER+7)
$define TTM_GETTOOLINFO	(WM_USER+8)
$define TTM_SETTOOLINFO	(WM_USER+9)
$define TTM_HITTEST	(WM_USER+10)
$define TTM_GETTEXT	(WM_USER+11)
$define TTM_UPDATETIPTEXT	(WM_USER+12)
$define TTM_GETTOOLCOUNT	(WM_USER+13)
$define TTM_ENUMTOOLS	(WM_USER+14)
$define TTM_GETCURRENTTOOL	(WM_USER+15)
$define TTM_WINDOWFROMPOINT	(WM_USER+16)
$define TTM_TRACKACTIVATE	  (WM_USER+17)  
$define TTM_TRACKPOSITION	  (WM_USER+18)  
$define TTM_SETTIPBKCOLOR	  (WM_USER+19)
$define TTM_SETTIPTEXTCOLOR	(WM_USER+20)
$define TTM_GETDELAYTIME	   (WM_USER+21)
$define TTM_GETTIPBKCOLOR	  (WM_USER+22)
$define TTM_GETTIPTEXTCOLOR	(WM_USER+23)
$define TTM_SETMAXTIPWIDTH	 (WM_USER+24)
$define TTM_GETMAXTIPWIDTH	 (WM_USER+25)
$define TTM_SETMARGIN		 (WM_USER+26)  
$define TTM_GETMARGIN		 (WM_USER+27)  
$define TTM_POP			  (WM_USER+28)
$define TTM_UPDATE		    (WM_USER+29)
$define TTM_GETBUBBLESIZE	(WM_USER+30)
$define TTM_ADJUSTRECT	(WM_USER+31)
$define TTM_SETTITLE	(WM_USER+32)
$define TTN_GETDISPINFO    (TTN_FIRST - 0)
$define TTN_NEEDTEXT	TTN_GETDISPINFOA
$define TTN_SHOW	(TTN_FIRST-1)
$define TTN_POP	(TTN_FIRST-2)
$define UD_MAXVAL	&h7fff
$define UD_MINVAL	(-UD_MAXVAL)
$define UDN_DELTAPOS (UDN_FIRST-1)
$define UDS_WRAP	1
$define UDS_SETBUDDYINT	2
$define UDS_ALIGNRIGHT	4
$define UDS_ALIGNLEFT	8
$define UDS_AUTOBUDDY	16
$define UDS_ARROWKEYS	32
$define UDS_HORZ	64
$define UDS_NOTHOUSANDS	128
$define UDS_HOTTRACK	&h0100
$define UDM_SETRANGE	(WM_USER+101)
$define UDM_GETRANGE	(WM_USER+102)
$define UDM_SETPOS	(WM_USER+103)
$define UDM_GETPOS	(WM_USER+104)
$define UDM_SETBUDDY	(WM_USER+105)
$define UDM_GETBUDDY	(WM_USER+106)
$define UDM_SETACCEL	(WM_USER+107)
$define UDM_GETACCEL	(WM_USER+108)
$define UDM_SETBASE	(WM_USER+109)
$define UDM_GETBASE	(WM_USER+110)
$define UDM_SETRANGE32	(WM_USER+111)
$define UDM_GETRANGE32	(WM_USER+112)
$define UDM_SETPOS32	(WM_USER+113)
$define UDM_GETPOS32	(WM_USER+114)
$define UDM_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define UDM_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT
$define SBT_TOOLTIPS	&h0800
$define SBN_SIMPLEMODECHANGE	(SBN_FIRST)
$define TBS_AUTOTICKS	1
$define TBS_VERT	2
$define TBS_HORZ	0
$define TBS_TOP	4
$define TBS_BOTTOM	0
$define TBS_LEFT	4
$define TBS_RIGHT	0
$define TBS_BOTH	8
$define TBS_NOTICKS	16
$define TBS_ENABLESELRANGE	32
$define TBS_FIXEDLENGTH	64
$define TBS_NOTHUMB	128
$define TBS_TOOLTIPS &h0100
$define TBTS_TOP 0
$define TBTS_LEFT 1
$define TBTS_BOTTOM 2
$define TBTS_RIGHT 3
$define TBS_REVERSED &h0200
$define TBS_DOWNISLEFT &h0400
$define TBIF_BYINDEX &h80000000
$define TBIF_COMMAND 32
$define TBIF_IMAGE 1
$define TBIF_LPARAM 16
$define TBIF_SIZE 64
$define TBIF_STATE 4
$define TBIF_STYLE 8
$define TBIF_TEXT 2
$define TBM_GETPOS	(WM_USER)
$define TBM_GETRANGEMIN	(WM_USER+1)
$define TBM_GETRANGEMAX	(WM_USER+2)
$define TBM_GETTIC	(WM_USER+3)
$define TBM_SETTIC	(WM_USER+4)
$define TBM_SETPOS	(WM_USER+5)
$define TBM_SETRANGE	(WM_USER+6)
$define TBM_SETRANGEMIN	(WM_USER+7)
$define TBM_SETRANGEMAX	(WM_USER+8)
$define TBM_CLEARTICS	(WM_USER+9)
$define TBM_SETSEL	(WM_USER+10)
$define TBM_SETSELSTART	(WM_USER+11)
$define TBM_SETSELEND	(WM_USER+12)
$define TBM_GETPTICS	(WM_USER+14)
$define TBM_GETTICPOS	(WM_USER+15)
$define TBM_GETNUMTICS	(WM_USER+16)
$define TBM_GETSELSTART	(WM_USER+17)
$define TBM_GETSELEND	(WM_USER+18)
$define TBM_CLEARSEL	(WM_USER+19)
$define TBM_SETTICFREQ	(WM_USER+20)
$define TBM_SETPAGESIZE	(WM_USER+21)
$define TBM_GETPAGESIZE	(WM_USER+22)
$define TBM_SETLINESIZE	(WM_USER+23)
$define TBM_GETLINESIZE	(WM_USER+24)
$define TBM_GETTHUMBRECT	(WM_USER+25)
$define TBM_GETCHANNELRECT	(WM_USER+26)
$define TBM_SETTHUMBLENGTH	(WM_USER+27)
$define TBM_GETTHUMBLENGTH	(WM_USER+28)
$define TBM_SETTOOLTIPS	(WM_USER+29)
$define TBM_GETTOOLTIPS	(WM_USER+30)
$define TBM_SETTIPSIDE	(WM_USER+31)
$define TBM_SETBUDDY	(WM_USER+32)
$define TBM_GETBUDDY	(WM_USER+33)
$define TBM_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT 
$define TBM_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define TB_LINEUP	0
$define TB_LINEDOWN	1
$define TB_PAGEUP	2
$define TB_PAGEDOWN	3
$define TB_THUMBPOSITION	4
$define TB_THUMBTRACK	5
$define TB_TOP	6
$define TB_BOTTOM	7
$define TB_ENDTRACK	8
$define HOTKEYF_SHIFT	1
$define HOTKEYF_CONTROL	2
$define HOTKEYF_ALT	4
$define HOTKEYF_EXT	8
$define HKCOMB_NONE	1
$define HKCOMB_S	2
$define HKCOMB_C	4
$define HKCOMB_A	8
$define HKCOMB_SC	16
$define HKCOMB_SA	32
$define HKCOMB_CA	64
$define HKCOMB_SCA	128
$define HKM_SETHOTKEY	(WM_USER+1)
$define HKM_GETHOTKEY	(WM_USER+2)
$define HKM_SETRULES	(WM_USER+3)
$define PBM_SETRANGE	(WM_USER+1)
$define PBM_SETPOS	(WM_USER+2)
$define PBM_DELTAPOS	(WM_USER+3)
$define PBM_SETSTEP	(WM_USER+4)
$define PBM_STEPIT	(WM_USER+5)
$define PBM_SETRANGE32	1030
$define PBM_GETRANGE	1031
$define PBM_GETPOS	1032
$define PBM_SETBARCOLOR	1033
$define PBM_SETBKCOLOR	CCM_SETBKCOLOR
$define PBS_SMOOTH	1
$define PBS_VERTICAL	4
$define LVS_ICON	0
$define LVS_REPORT	1
$define LVS_SMALLICON	2
$define LVS_LIST	3
$define LVS_TYPEMASK	3
$define LVS_SINGLESEL	4
$define LVS_SHOWSELALWAYS	8
$define LVS_SORTASCENDING	16
$define LVS_SORTDESCENDING	32
$define LVS_SHAREIMAGELISTS	64
$define LVS_NOLABELWRAP	128
$define LVS_AUTOARRANGE	256
$define LVS_EDITLABELS	512
$define LVS_NOSCROLL	&h2000
$define LVS_TYPESTYLEMASK	&hfc00
$define LVS_ALIGNTOP	0
$define LVS_ALIGNLEFT	&h800
$define LVS_ALIGNMASK	&hc00
$define LVS_OWNERDRAWFIXED	&h400
$define LVS_NOCOLUMNHEADER	&h4000
$define LVS_NOSORTHEADER	&h8000
$define CDIS_CHECKED 8
$define CDIS_DEFAULT 32
$define CDIS_DISABLED 4
$define CDIS_FOCUS 16
$define CDIS_GRAYED 2
$define CDIS_HOT 64
$define CDIS_SELECTED 1
$define CDIS_MARKED 128
$define CDIS_INDETERMINATE 256
$define CDIS_SHOWKEYBOARDCUES 512
$define CDDS_POSTERASE 4
$define CDDS_POSTPAINT 2
$define CDDS_PREERASE 3
$define CDDS_PREPAINT 1
$define CDDS_ITEM 65536
$define CDDS_ITEMPOSTERASE 65540
$define CDDS_ITEMPOSTPAINT 65538
$define CDDS_ITEMPREERASE 65539
$define CDDS_ITEMPREPAINT 65537
$define CDDS_SUBITEM &h20000
'' FIXME: missing CDRF_NOTIFYSUBITEMDRAW
$define CDRF_DODEFAULT 0
$define CDRF_NOTIFYITEMDRAW 32
$define CDRF_NOTIFYITEMERASE 128
$define CDRF_NOTIFYPOSTERASE 64
$define CDRF_NOTIFYPOSTPAINT 16
$define CDRF_NEWFONT 2
$define CDRF_SKIPDEFAULT 4
$define LVBKIF_SOURCE_NONE      &h00000000
$define LVBKIF_SOURCE_HBITMAP   &h00000001
$define LVBKIF_SOURCE_URL       &h00000002
$define LVBKIF_SOURCE_MASK      &h00000003
$define LVBKIF_STYLE_NORMAL     &h00000000
$define LVBKIF_STYLE_TILE       &h00000010
$define LVBKIF_STYLE_MASK       &h00000010
$define LVBKIF_FLAG_TILEOFFSET  &h00000100
$define LVBKIF_TYPE_WATERMARK   &h10000000
$define LVS_OWNERDATA 4096
$define LVS_EX_CHECKBOXES 4
$define LVS_EX_FULLROWSELECT 32
$define LVS_EX_GRIDLINES 1
$define LVS_EX_HEADERDRAGDROP 16
$define LVS_EX_ONECLICKACTIVATE 64
$define LVS_EX_SUBITEMIMAGES 2
$define LVS_EX_TRACKSELECT 8
$define LVS_EX_TWOCLICKACTIVATE 128
$define LVSICF_NOINVALIDATEALL	&h00000001
$define LVSICF_NOSCROLL	&h00000002
$define LVS_EX_FLATSB	&h00000100
$define LVS_EX_REGIONAL	&h00000200
$define LVS_EX_INFOTIP	&h00000400
$define LVS_EX_UNDERLINEHOT	&h00000800
$define LVS_EX_UNDERLINECOLD	&h00001000
$define LVS_EX_MULTIWORKAREAS	&h00002000
$define LVS_EX_LABELTIP	&h00004000
$define LVS_EX_BORDERSELECT	&h00008000
$define LVSIL_NORMAL	0
$define LVSIL_SMALL	1
$define LVSIL_STATE	2
$define LVM_GETBKCOLOR	LVM_FIRST
$define LVM_SETBKCOLOR	(LVM_FIRST+1)
$define LVM_GETIMAGELIST	(LVM_FIRST+2)
$define LVM_SETIMAGELIST	(LVM_FIRST+3)
$define LVM_GETITEMCOUNT	(LVM_FIRST+4)
$define LVIF_TEXT	1
$define LVIF_IMAGE	2
$define LVIF_PARAM	4
$define LVIF_STATE	8
$define LVIF_INDENT 16
$define LVIF_NORECOMPUTE 2048
$define LVIF_GROUPID 128
$define LVIF_COLUMNS 256
$define LVIS_FOCUSED	1
$define LVIS_SELECTED	2
$define LVIS_CUT	4
$define LVIS_DROPHILITED	8
$define LVIS_OVERLAYMASK	&hF00
$define LVIS_STATEIMAGEMASK	&hF000
$define LPSTR_TEXTCALLBACK	(-1)
$define I_IMAGECALLBACK	(-1)
$define LVM_GETITEM	(LVM_FIRST+5)
$define LVM_SETITEM	(LVM_FIRST+6)
$define LVM_INSERTITEM	(LVM_FIRST+7)
$define LVM_DELETEITEM	(LVM_FIRST+8)
$define LVM_DELETEALLITEMS	(LVM_FIRST+9)
$define LVM_GETCALLBACKMASK	(LVM_FIRST+10)
$define LVM_SETCALLBACKMASK	(LVM_FIRST+11)
$define LVM_SETBKIMAGE	(LVM_FIRST + 68)
$define LVM_GETBKIMAGE	(LVM_FIRST + 69)
$define LV_MAX_WORKAREAS	16
$define LVM_SETWORKAREAS	(LVM_FIRST+65)
$define LVM_GETWORKAREAS	(LVM_FIRST+70)
$define LVM_GETNUMBEROFWORKAREAS	(LVM_FIRST+73)
$define LVM_GETSELECTIONMARK	(LVM_FIRST+66)
$define LVM_SETSELECTIONMARK	(LVM_FIRST+67)
$define LVM_SETHOVERTIME	(LVM_FIRST+71)
$define LVM_GETHOVERTIME	(LVM_FIRST+72)
$define LVM_SETTOOLTIPS	(LVM_FIRST+74)
$define LVM_GETTOOLTIPS	(LVM_FIRST+78)
$define LVNI_ALL	0
$define LVNI_FOCUSED	1
$define LVNI_SELECTED	2
$define LVNI_CUT	4
$define LVNI_DROPHILITED	8
$define LVNI_ABOVE	256
$define LVNI_BELOW	512
$define LVNI_TOLEFT	1024
$define LVNI_TORIGHT	2048
$define LVM_GETNEXTITEM	(LVM_FIRST+12)
$define LVFI_PARAM	1
$define LVFI_STRING	2
$define LVFI_PARTIAL	8
$define LVFI_WRAP	32
$define LVFI_NEARESTXY	64
$define LVIF_DI_SETITEM	&h1000
$define LVM_FINDITEM	(LVM_FIRST+13)
$define LVIR_BOUNDS	0
$define LVIR_ICON	1
$define LVIR_LABEL	2
$define LVIR_SELECTBOUNDS	3
$define LVM_GETITEMRECT	(LVM_FIRST+14)
$define LVM_SETITEMPOSITION	(LVM_FIRST+15)
$define LVM_GETITEMPOSITION	(LVM_FIRST+16)
$define LVM_GETSTRINGWIDTH	(LVM_FIRST+17)
$define LVHT_NOWHERE	1
$define LVHT_ONITEMICON	2
$define LVHT_ONITEMLABEL	4
$define LVHT_ONITEMSTATEICON	8
$define LVHT_ONITEM	(LVHT_ONITEMICON or LVHT_ONITEMLABEL or LVHT_ONITEMSTATEICON)
$define LVHT_ABOVE	8
$define LVHT_BELOW	16
$define LVHT_TORIGHT	32
$define LVHT_TOLEFT	64
$define LVM_HITTEST	(LVM_FIRST+18)
$define LVM_ENSUREVISIBLE	(LVM_FIRST+19)
$define LVM_SCROLL	(LVM_FIRST+20)
$define LVM_REDRAWITEMS	(LVM_FIRST+21)
$define LVA_DEFAULT	0
$define LVA_ALIGNLEFT	1
$define LVA_ALIGNTOP	2
$define LVA_SNAPTOGRID	5
$define LVM_ARRANGE	(LVM_FIRST+22)
$define LVM_EDITLABEL	(LVM_FIRST+23)
$define LVM_GETEDITCONTROL	(LVM_FIRST+24)
$define LVCF_FMT	1
$define LVCF_WIDTH	2
$define LVCF_TEXT	4
$define LVCF_SUBITEM	8
$define LVCF_IMAGE 16
$define LVCF_ORDER 32
$define LVCFMT_LEFT	0
$define LVCFMT_RIGHT	1
$define LVCFMT_CENTER	2
$define LVCFMT_JUSTIFYMASK	3
$define LVCFMT_BITMAP_ON_RIGHT 4096
$define LVCFMT_COL_HAS_IMAGES  32768
$define LVCFMT_IMAGE 2048 
$define LVM_GETCOLUMN	(LVM_FIRST+25)
$define LVM_SETCOLUMN	(LVM_FIRST+26)
$define LVM_INSERTCOLUMN	(LVM_FIRST+27)
$define LVM_DELETECOLUMN	(LVM_FIRST+28)
$define LVM_GETCOLUMNWIDTH	(LVM_FIRST+29)
$define LVSCW_AUTOSIZE	(-1)
$define LVSCW_AUTOSIZE_USEHEADER	(-2)
$define LVM_SETCOLUMNWIDTH	(LVM_FIRST+30)
$define LVM_CREATEDRAGIMAGE	(LVM_FIRST+33)
$define LVM_GETVIEWRECT	(LVM_FIRST+34)
$define LVM_GETTEXTCOLOR	(LVM_FIRST+35)
$define LVM_SETTEXTCOLOR	(LVM_FIRST+36)
$define LVM_GETTEXTBKCOLOR	(LVM_FIRST+37)
$define LVM_SETTEXTBKCOLOR	(LVM_FIRST+38)
$define LVM_GETTOPINDEX	(LVM_FIRST+39)
$define LVM_GETCOUNTPERPAGE	(LVM_FIRST+40)
$define LVM_GETORIGIN	(LVM_FIRST+41)
$define LVM_UPDATE	(LVM_FIRST+42)
$define LVM_SETITEMSTATE	(LVM_FIRST+43)
$define LVM_GETITEMSTATE	(LVM_FIRST+44)
$define LVM_GETITEMTEXT	(LVM_FIRST+45)
$define LVM_SETITEMTEXT	(LVM_FIRST+46)
$define LVM_SETITEMCOUNT	(LVM_FIRST+47)
$define LVM_SORTITEMS	(LVM_FIRST+48)
$define LVM_SETITEMPOSITION32	(LVM_FIRST+49)
$define LVM_GETSELECTEDCOUNT	(LVM_FIRST+50)
$define LVM_GETITEMSPACING	(LVM_FIRST+51)
$define LVM_GETISEARCHSTRING	(LVM_FIRST+52)
$define LVM_APPROXIMATEVIEWRECT (LVM_FIRST+64)
$define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST+54)
$define LVM_GETEXTENDEDLISTVIEWSTYLE (LVM_FIRST+55)
$define LVM_SETCOLUMNORDERARRAY (LVM_FIRST+58)
$define LVM_GETCOLUMNORDERARRAY (LVM_FIRST+59)
$define LVM_GETHEADER (LVM_FIRST+31)
$define LVM_GETHOTCURSOR (LVM_FIRST+63)
$define LVM_GETHOTITEM (LVM_FIRST+61)
$define LVM_GETSUBITEMRECT (LVM_FIRST+56)
$define LVM_SETHOTCURSOR (LVM_FIRST+62)
$define LVM_SETHOTITEM (LVM_FIRST+60)
$define LVM_SETICONSPACING (LVM_FIRST+53)
$define LVM_SUBITEMHITTEST (LVM_FIRST+57)
$define LVN_ITEMCHANGING	LVN_FIRST
$define LVN_ITEMCHANGED	(LVN_FIRST-1)
$define LVN_INSERTITEM	(LVN_FIRST-2)
$define LVN_DELETEITEM	(LVN_FIRST-3)
$define LVN_DELETEALLITEMS	(LVN_FIRST-4)
$define LVN_BEGINLABELEDIT	(LVN_FIRST-5)
$define LVN_ENDLABELEDIT	(LVN_FIRST-6)
$define LVN_COLUMNCLICK	(LVN_FIRST-8)
$define LVN_BEGINDRAG	(LVN_FIRST-9)
$define LVN_BEGINRDRAG	(LVN_FIRST-11)
$define LVN_GETDISPINFO	(LVN_FIRST-50)
$define LVN_SETDISPINFO	(LVN_FIRST-51)
$define LVN_KEYDOWN	(LVN_FIRST-55)
$define LVN_GETINFOTIP	(LVN_FIRST-57)
$define LVKF_ALT	&h0001
$define LVKF_CONTROL	&h0002
$define LVKF_SHIFT	&h0004
$define LVGIT_UNFOLDED  1
$define TVS_HASBUTTONS	1
$define TVS_HASLINES	2
$define TVS_LINESATROOT	4
$define TVS_EDITLABELS	8
$define TVS_DISABLEDRAGDROP	16
$define TVS_SHOWSELALWAYS	32
$define TVS_CHECKBOXES 256
$define TVS_NOTOOLTIPS 128
$define TVS_RTLREADING 64
$define TVS_TRACKSELECT 512
$define TVS_FULLROWSELECT 4096
$define TVS_INFOTIP 2048
$define TVS_NONEVENHEIGHT 16384
$define TVS_NOSCROLL 8192
$define TVS_SINGLEEXPAND 1024
$define TVS_NOHSCROLL	&h8000
$define TVIF_TEXT	1
$define TVIF_IMAGE	2
$define TVIF_PARAM	4
$define TVIF_STATE	8
$define TVIF_HANDLE	16
$define TVIF_SELECTEDIMAGE	32
$define TVIF_CHILDREN	64
$define TVIF_INTEGRAL	&h0080
$define TVIS_FOCUSED	1
$define TVIS_SELECTED	2
$define TVIS_CUT	4
$define TVIS_DROPHILITED	8
$define TVIS_BOLD	16
$define TVIS_EXPANDED	32
$define TVIS_EXPANDEDONCE	64
$define TVIS_OVERLAYMASK	&hF00
$define TVIS_STATEIMAGEMASK	&hF000
$define TVIS_USERMASK	&hF000
$define I_CHILDRENCALLBACK	(-1)
$define TVI_ROOT	(&hFFFF0000)
$define TVI_FIRST	(&hFFFF0001)
$define TVI_LAST	(&hFFFF0002)
$define TVI_SORT	(&hFFFF0003)
$define TVSIL_NORMAL	0
$define TVSIL_STATE	2
$define TVM_INSERTITEM	TV_FIRST
$define TVM_DELETEITEM	(TV_FIRST+1)
$define TVM_EXPAND	(TV_FIRST+2)
$define TVM_GETITEMRECT	(TV_FIRST+4)
$define TVM_GETCOUNT	(TV_FIRST+5)
$define TVM_GETINDENT	(TV_FIRST+6)
$define TVM_SETINDENT	(TV_FIRST+7)
$define TVM_GETIMAGELIST	(TV_FIRST+8)
$define TVM_SETIMAGELIST	(TV_FIRST+9)
$define TVM_GETNEXTITEM	(TV_FIRST+10)
$define TVM_SELECTITEM	(TV_FIRST+11)
$define TVM_GETITEM	(TV_FIRST+12)
$define TVM_SETITEM	(TV_FIRST+13)
$define TVM_EDITLABEL	(TV_FIRST+14)
$define TVM_GETEDITCONTROL	(TV_FIRST+15)
$define TVM_GETVISIBLECOUNT	(TV_FIRST+16)
$define TVM_HITTEST	(TV_FIRST+17)
$define TVM_CREATEDRAGIMAGE	(TV_FIRST+18)
$define TVM_SORTCHILDREN	(TV_FIRST+19)
$define TVM_ENSUREVISIBLE	(TV_FIRST+20)
$define TVM_SORTCHILDRENCB	(TV_FIRST+21)
$define TVM_ENDEDITLABELNOW	(TV_FIRST+22)
$define TVM_GETISEARCHSTRING	(TV_FIRST+23)
$define TVM_GETTOOLTIPS (TV_FIRST+25)
$define TVM_SETTOOLTIPS (TV_FIRST+24)
$define TVM_GETBKCOLOR (TV_FIRST+31)
$define TVM_GETINSERTMARKCOLOR (TV_FIRST+38)
$define TVM_GETITEMHEIGHT (TV_FIRST+28)
$define TVM_GETSCROLLTIME (TV_FIRST+34)
$define TVM_GETTEXTCOLOR (TV_FIRST+32)
$define TVM_SETBKCOLOR (TV_FIRST+29)
$define TVM_SETINSERTMARK (TV_FIRST+26)
$define TVM_SETINSERTMARKCOLOR (TV_FIRST+37)
$define TVM_SETITEMHEIGHT (TV_FIRST+27)
$define TVM_SETSCROLLTIME (TV_FIRST+33)
$define TVM_SETTEXTCOLOR (TV_FIRST+30)
$define TVM_SETUNICODEFORMAT CCM_SETUNICODEFORMAT
$define TVM_GETUNICODEFORMAT CCM_GETUNICODEFORMAT
$define TVM_GETITEMSTATE (TV_FIRST+39)
$define TVM_SETLINECOLOR (TV_FIRST+40)
$define TVM_GETLINECOLOR (TV_FIRST+41)
$define TVE_COLLAPSE	1
$define TVE_EXPAND	2
$define TVE_TOGGLE	3
$define TVE_COLLAPSERESET	&h8000
$define TVE_EXPANDPARTIAL	&h4000
$define TVC_UNKNOWN	0
$define TVC_BYMOUSE	1
$define TVC_BYKEYBOARD	2
$define TVGN_ROOT	0
$define TVGN_NEXT	1
$define TVGN_PREVIOUS	2
$define TVGN_PARENT	3
$define TVGN_CHILD	4
$define TVGN_FIRSTVISIBLE	5
$define TVGN_NEXTVISIBLE	6
$define TVGN_PREVIOUSVISIBLE	7
$define TVGN_DROPHILITE	8
$define TVGN_CARET	9
$define TVGN_LASTVISIBLE	10
$define TVN_SELCHANGING	(TVN_FIRST-1)
$define TVN_SELCHANGED	(TVN_FIRST-2)
$define TVN_GETDISPINFO	(TVN_FIRST-3)
$define TVN_SETDISPINFO	(TVN_FIRST-4)
$define TVN_ITEMEXPANDING	(TVN_FIRST-5)
$define TVN_ITEMEXPANDED	(TVN_FIRST-6)
$define TVN_BEGINDRAG	(TVN_FIRST-7)
$define TVN_BEGINRDRAG	(TVN_FIRST-8)
$define TVN_DELETEITEM	(TVN_FIRST-9)
$define TVN_BEGINLABELEDIT	(TVN_FIRST-10)
$define TVN_ENDLABELEDIT	(TVN_FIRST-11)
$define TVN_KEYDOWN	(TVN_FIRST-12)
$define TVN_GETINFOTIP	(TVN_FIRST-13)
$define TVN_SINGLEEXPAND	(TVN_FIRST-15)
$define TVNRET_DEFAULT 0
$define TVNRET_SKIPOLD 1
$define TVNRET_SKIPNEW 2
$define TVIF_DI_SETITEM	&h1000
$define TVHT_NOWHERE	1
$define TVHT_ONITEMICON	2
$define TVHT_ONITEMLABEL	4
$define TVHT_ONITEM	(TVHT_ONITEMICON or TVHT_ONITEMLABEL or TVHT_ONITEMSTATEICON)
$define TVHT_ONITEMINDENT	8
$define TVHT_ONITEMBUTTON	16
$define TVHT_ONITEMRIGHT	32
$define TVHT_ONITEMSTATEICON	64
$define TVHT_ABOVE	256
$define TVHT_BELOW	512
$define TVHT_TORIGHT	1024
$define TVHT_TOLEFT	2048
$define TCHT_NOWHERE	1
$define TCHT_ONITEMICON	2
$define TCHT_ONITEMLABEL	4
$define TCHT_ONITEM	(TCHT_ONITEMICON or TCHT_ONITEMLABEL)
$define TCS_FORCEICONLEFT	16
$define TCS_FORCELABELLEFT	32
$define TCS_TABS	0
$define TCS_BUTTONS	256
$define TCS_SINGLELINE	0
$define TCS_MULTILINE	512
$define TCS_RIGHTJUSTIFY	0
$define TCS_FIXEDWIDTH	1024
$define TCS_RAGGEDRIGHT	2048
$define TCS_FOCUSONBUTTONDOWN	&h1000
$define TCS_OWNERDRAWFIXED	&h2000
$define TCS_TOOLTIPS	&h4000
$define TCS_FOCUSNEVER	&h8000
$define TCS_BOTTOM	2
$define TCS_RIGHT	2
$define TCS_VERTICAL	128
$define TCS_SCROLLOPPOSITE	&h0001
$define TCS_HOTTRACK	&h0040
$define TCS_MULTISELECT	&h0004
$define TCS_FLATBUTTONS	&h0008
$define TCS_EX_FLATSEPARATORS	&h00000001
$define TCS_EX_REGISTERDROP	&h00000002
$define TCIF_TEXT	1
$define TCIF_IMAGE	2
$define TCIF_RTLREADING	4
$define TCIF_PARAM	8
$define TCIF_STATE	16
$define TCM_FIRST	&h1300
$define TCM_GETIMAGELIST	(TCM_FIRST+2)
$define TCM_SETIMAGELIST	(TCM_FIRST+3)
$define TCM_GETITEMCOUNT	(TCM_FIRST+4)
$define TCM_GETITEM	(&h1305)
$define TCM_SETITEM	(&h1306)
$define TCM_INSERTITEM	(TCM_FIRST+7)
$define TCM_DELETEITEM	(TCM_FIRST+8)
$define TCM_DELETEALLITEMS	(TCM_FIRST+9)
$define TCM_GETITEMRECT	(TCM_FIRST+10)
$define TCM_GETCURSEL	(TCM_FIRST+11)
$define TCM_SETCURSEL	(TCM_FIRST+12)
$define TCM_HITTEST	(TCM_FIRST+13)
$define TCM_SETITEMEXTRA	(TCM_FIRST+14)

$define TCM_ADJUSTRECT	(TCM_FIRST+40)
$define TCM_SETITEMSIZE	(TCM_FIRST+41)
$define TCM_REMOVEIMAGE	(TCM_FIRST+42)
$define TCM_SETPADDING	(TCM_FIRST+43)
$define TCM_GETROWCOUNT	(TCM_FIRST+44)
$define TCM_GETTOOLTIPS	(TCM_FIRST+45)
$define TCM_SETTOOLTIPS	(TCM_FIRST+46)
$define TCM_GETCURFOCUS	(TCM_FIRST+47)
$define TCM_SETCURFOCUS	(TCM_FIRST+48)
$define TCM_SETMINTABWIDTH	(TCM_FIRST + 49)
$define TCM_DESELECTALL	(TCM_FIRST + 50)
$define TCM_HIGHLIGHTITEM	(TCM_FIRST + 51)
$define TCM_SETEXTENDEDSTYLE	(TCM_FIRST + 52)
$define TCM_GETEXTENDEDSTYLE	(TCM_FIRST + 53)
$define TCM_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define TCM_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT
$define TCN_KEYDOWN	TCN_FIRST
$define TCN_SELCHANGE	(TCN_FIRST-1)
$define TCN_SELCHANGING	(TCN_FIRST-2)
$define NM_OUTOFMEMORY (NM_FIRST-1)
$define NM_CLICK (NM_FIRST-2)
$define NM_DBLCLK (NM_FIRST-3)
$define NM_RETURN (NM_FIRST-4)
$define NM_RCLICK (NM_FIRST-5)
$define NM_RDBLCLK (NM_FIRST-6)
$define NM_SETFOCUS (NM_FIRST-7)
$define NM_KILLFOCUS (NM_FIRST-8)
$define NM_CUSTOMDRAW (NM_FIRST-12)
$define NM_HOVER (NM_FIRST-13)
$define NM_NCHITTEST (NM_FIRST-14)
$define NM_KEYDOWN (NM_FIRST-15)
$define NM_RELEASEDCAPTURE (NM_FIRST-16)
$define NM_SETCURSOR (NM_FIRST-17)
$define NM_CHAR (NM_FIRST-18)
$define NM_TOOLTIPSCREATED (NM_FIRST-19)
$define SBARS_SIZEGRIP 256
$define CCM_FIRST &h2000
$define CCM_LAST (CCM_FIRST+&h200)
$define CCM_SETBKCOLOR 8193
$define CCM_SETCOLORSCHEME 8194
$define CCM_GETCOLORSCHEME 8195
$define CCM_GETDROPTARGET 8196
$define CCM_SETUNICODEFORMAT 8197
$define CCM_GETUNICODEFORMAT 8198
$define CCM_SETVERSION &h2007
$define CCM_GETVERSION &h2008
$define CCM_SETNOTIFYWINDOW &h2009
$define CCM_SETWINDOWTHEME &h200b
$define CCM_DPISCALE &h200c
$define ICC_LISTVIEW_CLASSES 1
$define ICC_TREEVIEW_CLASSES 2
$define ICC_BAR_CLASSES	4
$define ICC_TAB_CLASSES      8
$define ICC_UPDOWN_CLASS 16
$define ICC_PROGRESS_CLASS 32
$define ICC_HOTKEY_CLASS 64
$define ICC_ANIMATE_CLASS 128
$define ICC_WIN95_CLASSES 255
$define ICC_DATE_CLASSES 256
$define ICC_USEREX_CLASSES 512
$define ICC_COOL_CLASSES 1024
$define ICC_INTERNET_CLASSES 2048
$define ICC_PAGESCROLLER_CLASS 4096
$define ICC_NATIVEFNTCTL_CLASS 8192
$define INFOTIPSIZE 1024
$define GDTR_MIN 1
$define GDTR_MAX 2
$define GMR_VISIBLE 0
$define GMR_DAYSTATE 1
$define GDT_ERROR -1
$define GDT_VALID 0
$define GDT_NONE 1
$define DTS_UPDOWN 1
$define DTS_SHOWNONE 2
$define DTS_SHORTDATEFORMAT 0
$define DTS_LONGDATEFORMAT 4
$define DTS_TIMEFORMAT 9
$define DTS_APPCANPARSE 16
$define DTS_RIGHTALIGN 32
$define DTS_SHORTDATECENTURYFORMAT	&h000C
$define MCS_DAYSTATE 1
$define MCS_MULTISELECT 2
$define MCS_WEEKNUMBERS 4
$define MCS_NOTODAYCIRCLE	&h0008
$define MCS_NOTODAY	&h0010
$define DTM_GETSYSTEMTIME &h1001
$define DTM_SETSYSTEMTIME &h1002
$define DTM_GETRANGE &h1003
$define DTM_SETRANGE &h1004
$define DTM_SETFORMAT &h1005
$define DTM_SETMCCOLOR &h1006
$define DTM_GETMCCOLOR &h1007
$define DTM_GETMONTHCAL &h1008
$define DTM_SETMCFONT	&h1009
$define DTM_GETMCFONT	&h100a
$define DTN_USERSTRING  (-758)
$define DTN_WMKEYDOWN  (-757)
$define DTN_FORMAT  (-756) 
$define DTN_FORMATQUERY  (-755) 
$define DTN_DROPDOWN    (-754) 
$define DTN_CLOSEUP	(-753) 
$define DTN_DATETIMECHANGE (-759) 
$define MCM_GETCURSEL	&h1001
$define MCM_SETCURSEL	&h1002
$define MCM_GETMAXSELCOUNT &h1003
$define MCM_SETMAXSELCOUNT &h1004
$define MCM_GETSELRANGE	&h1005
$define MCM_SETSELRANGE	&h1006
$define MCM_GETMONTHRANGE &h1007
$define MCM_SETDAYSTATE	&h1008
$define MCM_GETMINREQRECT &h1009
$define MCM_SETCOLOR &h100a
$define MCM_GETCOLOR &h100b
$define MCM_SETTODAY &h100c
$define MCM_GETTODAY &h100d
$define MCM_HITTEST &h100e
$define MCM_SETFIRSTDAYOFWEEK &h100f
$define MCM_GETFIRSTDAYOFWEEK &h1010
$define MCM_GETRANGE &h1011
$define MCM_SETRANGE &h1012
$define MCM_GETMONTHDELTA &h1013
$define MCM_SETMONTHDELTA &h1014
$define MCM_GETMAXTODAYWIDTH &h1015
$define MCN_SELCHANGE	  (-749)
$define MCN_GETDAYSTATE	(-747)
$define MCN_SELECT		(-746)
$define ODT_HEADER 100
$define ODT_TAB 101
$define ODT_LISTVIEW 102
$define SB_SETBKCOLOR	&h2001
$define SB_ISSIMPLE 1038
$define MCSC_BACKGROUND 0
$define MCSC_TEXT 1
$define MCSC_TITLEBK 2
$define MCSC_TITLETEXT 3
$define MCSC_MONTHBK 4
$define MCSC_TRAILINGTEXT 5
$define MCHT_TITLE &h10000
$define MCHT_CALENDAR &h20000
$define MCHT_TODAYLINK &h30000
$define MCHT_NEXT &h1000000
$define MCHT_PREV &h2000000
$define MCHT_NOWHERE &h00
$define MCHT_TITLEBK (MCHT_TITLE)
$define MCHT_TITLEMONTH (MCHT_TITLE  or  &h0001)
$define MCHT_TITLEYEAR (MCHT_TITLE  or  &h0002)
$define MCHT_TITLEBTNNEXT (MCHT_TITLE  or  MCHT_NEXT  or  &h0003)
$define MCHT_TITLEBTNPREV (MCHT_TITLE  or  MCHT_PREV  or  &h0003)
$define MCHT_CALENDARBK (MCHT_CALENDAR)
$define MCHT_CALENDARDATE (MCHT_CALENDAR  or  &h0001)
$define MCHT_CALENDARDATENEXT (MCHT_CALENDARDATE  or  MCHT_NEXT)
$define MCHT_CALENDARDATEPREV (MCHT_CALENDARDATE  or  MCHT_PREV)
$define MCHT_CALENDARDAY (MCHT_CALENDAR  or  &h0002)
$define MCHT_CALENDARWEEKNUM (MCHT_CALENDAR  or  &h0003)
$define RBS_TOOLTIPS 256
$define RBS_VARHEIGHT 512
$define RBS_BANDBORDERS 1024
$define RBS_FIXEDORDER 2048
$define RBIM_IMAGELIST 1
$define RB_SETCOLORSCHEME CCM_SETCOLORSCHEME
$define RB_GETCOLORSCHEME CCM_GETCOLORSCHEME
$define RBBS_BREAK 1
$define RBBS_FIXEDSIZE 2
$define RBBS_CHILDEDGE 4
$define RBBS_HIDDEN 8
$define RBBS_NOVERT 16
$define RBBS_FIXEDBMP 32
$define RBBIM_STYLE 1
$define RBBIM_COLORS 2
$define RBBIM_TEXT 4
$define RBBIM_IMAGE 8
$define RBBIM_CHILD 16
$define RBBIM_CHILDSIZE 32
$define RBBIM_SIZE 64
$define RBBIM_BACKGROUND 128
$define RBBIM_ID 256
$define RB_INSERTBAND (WM_USER+1)
$define RB_DELETEBAND (WM_USER+2)
$define RB_GETBARINFO (WM_USER+3)
$define RB_SETBARINFO (WM_USER+4)
$define RB_GETBANDCOUNT (WM_USER+12)
$define RB_GETROWCOUNT (WM_USER+13)
$define RB_GETROWHEIGHT (WM_USER+14)
$define RB_SETBANDINFO (WM_USER+6)
$define RB_SETPARENT (WM_USER+7)
$define RBN_HEIGHTCHANGE RBN_FIRST
$define LVN_ODCACHEHINT (LVN_FIRST-13)
$define LVN_ODFINDITEM (LVN_FIRST-52)
$define LVN_ITEMACTIVATE (LVN_FIRST-14)
$define LVN_ODSTATECHANGED (LVN_FIRST-15)
$define SB_SETICON 1039
$define SB_SETTIPTEXT	1040
$define SB_GETTIPTEXT	1042
$define SB_GETICON	1044
$define SB_SETUNICODEFORMAT	&h2005
$define SB_GETUNICODEFORMAT	&h2006
$define PGF_INVISIBLE 0
$define PGF_NORMAL 1
$define PGF_GRAYED 2
$define PGF_DEPRESSED 4
$define PGF_HOT 8
$define PGB_TOPORLEFT 0
$define PGB_BOTTOMORRIGHT 1
$define PGF_SCROLLUP 1
$define PGF_SCROLLDOWN 2
$define PGF_SCROLLLEFT 4
$define PGF_SCROLLRIGHT 8
$define PGK_SHIFT 1
$define PGK_CONTROL 2
$define PGK_MENU 4
$define PGF_CALCWIDTH 1
$define PGF_CALCHEIGHT 2
$define PGM_FIRST &h1400
$define PGM_SETCHILD (PGM_FIRST+1)
$define PGM_RECALCSIZE (PGM_FIRST+2)
$define PGM_FORWARDMOUSE (PGM_FIRST+3)
$define PGM_SETBKCOLOR (PGM_FIRST+4)
$define PGM_GETBKCOLOR (PGM_FIRST+5)
$define PGM_SETBORDER (PGM_FIRST+6)
$define PGM_GETBORDER (PGM_FIRST+7)
$define PGM_SETPOS (PGM_FIRST+8)
$define PGM_GETPOS (PGM_FIRST+9)
$define PGM_SETBUTTONSIZE (PGM_FIRST+10)
$define PGM_GETBUTTONSIZE (PGM_FIRST+11)
$define PGM_GETBUTTONSTATE (PGM_FIRST+12)
$define PGM_GETDROPTARGET CCM_GETDROPTARGET

$define RBS_REGISTERDROP 4096
$define RBS_AUTOSIZE 8192
$define RBS_VERTICALGRIPPER 16384
$define RBS_DBLCLKTOGGLE  32768
$define RBBS_VARIABLEHEIGHT 64
$define RBBS_GRIPPERALWAYS 128
$define RBBS_NOGRIPPER 256
$define RBBIM_IDEALSIZE 512
$define RBBIM_LPARAM 1024
$define RBBIM_HEADERSIZE 2048
$define RB_HITTEST (WM_USER+8)
$define RB_GETRECT (WM_USER+9)
$define RB_IDTOINDEX (WM_USER+16)
$define RB_GETTOOLTIPS (WM_USER+17)
$define RB_SETTOOLTIPS (WM_USER+18)
$define RB_SETBKCOLOR (WM_USER+19)
$define RB_GETBKCOLOR (WM_USER+20)
$define RB_SETTEXTCOLOR (WM_USER+21)
$define RB_GETTEXTCOLOR (WM_USER+22)
$define RB_SIZETORECT (WM_USER+23)
$define RB_BEGINDRAG (WM_USER+24)
$define RB_ENDDRAG (WM_USER+25)
$define RB_DRAGMOVE (WM_USER+26)
$define RB_GETBARHEIGHT (WM_USER+27)
$define RB_GETBANDINFO (WM_USER+29)
$define RB_MINIMIZEBAND (WM_USER+30)
$define RB_MAXIMIZEBAND (WM_USER+31)
$define RB_GETDROPTARGET CCM_GETDROPTARGET
$define RB_GETBANDBORDERS (WM_USER+34)
$define RB_SHOWBAND (WM_USER+35)
$define RB_SETPALETTE (WM_USER+37)
$define RB_GETPALETTE (WM_USER+38)
$define RB_MOVEBAND (WM_USER+39)
$define RB_SETUNICODEFORMAT     CCM_SETUNICODEFORMAT
$define RB_GETUNICODEFORMAT     CCM_GETUNICODEFORMAT
$define RBN_GETOBJECT (RBN_FIRST-1)
$define RBN_LAYOUTCHANGED (RBN_FIRST-2)
$define RBN_AUTOSIZE (RBN_FIRST-3)
$define RBN_BEGINDRAG (RBN_FIRST-4)
$define RBN_ENDDRAG (RBN_FIRST-5)
$define RBN_DELETINGBAND (RBN_FIRST-6)
$define RBN_DELETEDBAND (RBN_FIRST-7)
$define RBN_CHILDSIZE (RBN_FIRST-8)
$define RBNM_ID 1
$define RBNM_STYLE 2
$define RBNM_LPARAM 4
$define RBHT_NOWHERE 1
$define RBHT_CAPTION 2
$define RBHT_CLIENT 3
$define RBHT_GRABBER 4
$define CBEM_INSERTITEM	(WM_USER + 1)
$define CBEM_SETIMAGELIST	(WM_USER + 2)
$define CBEM_GETIMAGELIST	(WM_USER + 3)
$define CBEM_GETITEM	(WM_USER + 4)
$define CBEM_SETITEM	(WM_USER + 5)
$define CBEM_DELETEITEM	CB_DELETESTRING
$define CBEM_GETCOMBOCONTROL	(WM_USER + 6)
$define CBEM_GETEDITCONTROL	(WM_USER + 7)
$define CBEM_SETEXSTYLE	(WM_USER + 8)
$define CBEM_GETEXSTYLE	(WM_USER + 9)
$define CBEM_SETEXTENDEDSTYLE	(WM_USER + 14)
$define CBEM_GETEXTENDEDSTYLE	(WM_USER + 9)
$define CBEM_SETUNICODEFORMAT	CCM_SETUNICODEFORMAT
$define CBEM_GETUNICODEFORMAT	CCM_GETUNICODEFORMAT
$define CBEM_HASEDITCHANGED	(WM_USER + 10)


