'*
'* EditForm
'*
unit User.FormBuilder.EditForm

import windows.gui.*
import User.FormBuilder.*

declare sub EditForm_OnPaint ( byref Form as Form )
declare sub EventForm_OnResize ( byref Form as Form )
declare sub EventForm_Change ( byref w as Widget )
declare sub EventForm_OnClose ( byref w as Widget )




'* Form Designer Class
published class EditForm: implements Form 

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
      end sub

      sub EditForm ()

end class


'* Event Editor Class ( for Edit Events )
public class EventEdit: implements Form

    dim Edit as Memo (this)
    dim EvData as pointer = null
    sub EventEdit ()

end class

sub EventEdit.EventEdit ()

    with this
         '.Visible = true
         .Move (220+20,10+20,500,400)
         .Caption = " "
         .OnResize = subptr ( EventForm_OnResize )

         .Edit.Font.FontName = "Courier New"
         .Edit.Font.Height = 16
         .Edit.Caption = ""
         .Edit.Show()
         .Edit.OnChange = subptr ( EventForm_Change )
         .Edit.Move (0,0,.ClientWidth,.ClientHeight)
    end with

end sub


sub EditForm.EditForm ()

    with this

         .ClassName = "Form"
         .Move (220, 10, 500, 400)
         .Caption = "Form1"
         .OnPaint = subptr ( EditForm_OnPaint )
         .OnClose = subptr ( EventForm_OnClose ) 
         '.Visible = true
          this.WndProc = subptr ( Design_WndProcForm )
         
    end with

    'this.Brush.LogBrush.lbHatch = HS_VERTICAL
    'this.Brush.LogBrush.lbStyle = BS_HATCHED
    'this.Brush.Color = 0xFF00FF


end sub


sub EditForm_OnPaint ( byref Form as Form )

dim x as integer, y as integer
dim w as integer, h as integer
w = Form.Width
h = Form.Height

    'Form.Canvas.Brush.Color = 10
with Form.Canvas
    for x = 0 to w step 8
    for y = 0 to h step 8
'        Form.Canvas.Rectangle (x,y,x+2,y+2)
        SetPixelV (.hDC, x,y,0)
    next
    next
end with


    'Form.Canvas.Rectangle (0,0,Form.Width,Form.Height)
end sub

sub EventForm_OnResize ( byref Form as Form )
dim byref ef as EventEdit
set ef = ref Form

    ef.Edit.Move ( 0, 0,ef.ClientWidth, ef.ClientHeight )
    ef.Edit.Refresh()

end sub

sub EventForm_OnClose ( byref w as Widget )
end sub

sub EventForm_Change ( byref m as Memo )

dim byref ef as EventEdit
set ef = m.GetParentClass()
if ef.EvData <> null then
   dim byref ed as EventData
   set ed = ef.EvData
   ed.Text = m.Caption
   'msgbox m.Caption
   'f = fopen "1.txt", "w+"
   'fprint f, m.caption



end if
end sub
