'**
'*    SemanticExpert ( Wizard )
'*
class Sem_Progress: implements Form
      dim Bar as ProgressBar (this)
      dim Comment as Static (this)
      sub Sem_Progress()
end class

sub Sem_Progress.Sem_Progress()

    with this
         .Width = 600
         .Height = 100
         .Caption = "  ..."
    end with

    with this.bar
         .Min = 0
         .Max = 100
         .Pos = 0
         .Move (10,10,580,20)
         .BarColor.Color = 0x0000AA
    end with

    with this.Comment
         .Move (10,45,300,30)
         .Caption = ""
         .Visible = true
    end with

end sub


class SemanticBuilder: implements Object
 
sub Build (byval FileNameEXE as string)

 dim fb as Sem_Progress ()
 fb.Show


 dim t_var as SmallTable
 dim t_Act as SmallTable
 dim t_Set as SmallTable

 dim t_start_action as string


 t_var.Open ("Data\Variables.txt")
 t_Act.Open ("Data\Actions.txt")
 t_Set.Open ("Data\Settings.txt")

 dim f as FILE
 f = fopen ("Code.bas", "w+")
  fprint f, "' WARNING! Machine generated!\n"
  fprint f, "$STACK 300000\n"
  fprint f, "$include \'rus.inc\'\n"
  t_act.cursor = 1
  do
    dim t_action as string = trim(t_act.getstr ("Action"))
    dim t_form as string = trim(t_act.getstr("Form"))
    fprint f, "$include \'"+t_form+".class\'\n"
    if t_act.eof then exit do
    t_act.next
  loop

  do
    dim df as string = trim(t_var.get ("Value"))
    dim tp as string = trim(t_var.get("Type"))
    fprint f, "dim ", trim(t_var.get ("Name")), " as ", trim(t_var.get ("Type")), " = ", df, "\n"
    if t_var.eof then exit do
    t_var.next
  loop

  fprint f, "$include \'SemRunTime.bas\'\n"

  t_act.cursor = 1
  do
    dim t_ad as string = trim(t_act.getstr ("Action"))
    fprint f, "declare sub " + t_ad + "\n"
    if t_act.eof then exit do
    t_act.next
  loop


  fprint f, "sub Read_Border ()\n"
  fprint f, "with ExpertForm\n"
  t_var.cursor = 1
  do
    dim d_df as string = trim(t_var.get ("Value"))
    dim d_tp as string = trim(t_var.get("Type"))
    dim d_nm as string = trim(t_var.get("Name"))

    'fprint f, "dim ", trim(t_var.get ("Name")), " as ", trim(t_var.get ("Type")), " = ", df, "\n"

    fprint f, "    if Have_ValueR ( .Border, \'"+d_nm+"\' ) then \n"

    if lcase(d_tp) = "string" then
    fprint f, "       " + d_nm + " = Query_Value ( .Border, \'"+d_nm+"\' )\n"
    else
    fprint f, "       " + d_nm + " = val(Query_Value ( .Border, \'"+d_nm+"\' ))\n"
    end if

    if lcase(d_tp) = "string" then
    fprint f, "       Store_Value (\'"+d_nm+"\',"+d_nm+")\n"
    else
    fprint f, "       Store_Value (\'"+d_nm+"\',str("+d_nm+"))\n"
    end if



    fprint f, "    end if\n"

    if t_var.eof then exit do
    t_var.next
  loop
  fprint f, "end with\n"
  fprint f, "end sub\n"

  fprint f, "sub Restore_Border ()\n"
  fprint f, "with ExpertForm\n"
  t_var.cursor = 1
  do
    dim d2_df as string = trim(t_var.get ("Value"))
    dim d2_tp as string = trim(t_var.get("Type"))
    dim d2_nm as string = trim(t_var.get("Name"))

    'fprint f, "dim ", trim(t_var.get ("Name")), " as ", trim(t_var.get ("Type")), " = ", df, "\n"

    fprint f, "    if Have_Value ( .Border, \'"+d2_nm+"\' ) then \n"

    'if lcase(d_tp) = "string" then
    'fprint f, "       " + d_nm + " = Query_Value ( .Border, \'"+d_nm+"\' )\n"
    'else
    'fprint f, "       " + d_nm + " = val(Query_Value ( .Border, \'"+d_nm+"\' ))\n"
    'end if

    if lcase(d2_tp) = "string" then
    fprint f, "       Post_Value ( .Border, \'"+d2_nm+"\',"+d2_nm+")\n"
    else
    fprint f, "       Post_Value ( .Border, \'"+d2_nm+"\',str("+d2_nm+"))\n"
    end if



    fprint f, "    end if\n"

    if t_var.eof then exit do
    t_var.next
  loop
  fprint f, "end with\n"
  fprint f, "end sub\n"


  t_act.cursor = t_act.rowcount
  dim t_anm as string = trim(t_act.getstr ("Action"))
  fprint f, "sub GoFinish ()\n"
  fprint f, "    "+t_anm+"()\n"
  fprint f, "end sub\n"


  fb.Bar.Max = t_act.RowCount+1
  t_act.cursor = 1
  do
  fb.Bar.Pos = t_act.cursor
  fb.Refresh()
  fb.Bar.Refresh()

    dim t_action as string = trim(t_act.getstr ("Action"))
    dim t_form as string = trim(t_act.getstr("Form"))
    dim t_proc as string = trim(t_act.getstr ("Procedure"))
    dim t_logic as string = trim(t_act.getstr ("Logic"))
    dim t_t as string = trim(t_act.getstr ("True"))
    dim t_f as string = trim(t_act.getstr ("False"))
    dim t_desc as string = trim(t_act.getstr ("Desc"))
    dim t_calc as string = trim(t_act.getstr ("Calc"))

  fb.Comment.Caption = t_action + " ... " 
  fb.Comment.Refresh()
  doevents


    WinExec "formbuilder.exe build " + ""+t_form + " " + ""+t_form+".class", 10


    if t_act.cursor = 1 then
       t_start_action = t_action
    end if
    

    fprint f, "sub " + t_action + " () \n"
    fprint f, "do\n"
    fprint f, "    " + "dim byref InstanceForm as "+t_action+"\n"
    fprint f, "    " + "set InstanceForm = new "+t_action+"()\n"
    fprint f, "    " + "InstanceForm.Visible = false\n"
        

    fprint f, "    " + "Drop_Control ( ExpertForm.Border )\n"
    fprint f, "    " + "ExpertForm.Border.Visible = false\n"
    fprint f, "    " + "ExpertForm.ActDesc.Caption = \' \' + str(Act_Step) + \' : " + t_desc + "\'\n" 

    if not (t_calc = "") then
    dim byref sbb3 as StringBuffer
    set sbb3 = new StringBuffer ()
    sbb3 = file (t_calc)
    dim i4 as integer, c4 as integer
    c4 = sbb3.Count
    if c4 > 0 then
    for i4 = 0 to c4 - 1
        fprint f, sbb3.item (i4), ""
    next
    end if
    fprint f, "\n"
    delete sbb3
    end if


    'fprint f, "    " + "FlipControlFromFile ( ExpertForm.Border, \'" + t_form + "\' )\n"
    fprint f, "    " + "RelocateForm ( ExpertForm.Border, InstanceForm )\n"
    fprint f, "    Restore_Border ()\n"
    fprint f, "    " + "ExpertForm.Border.Visible = true\n"
    fprint f, "    hit = WaitForAction ()\n"
    fprint f, "    decision = 1\n"

    fprint f, "    " + "Read_Border ()" + "\n"

    dim byref sbb as StringBuffer
    set sbb = new StringBuffer ()
    sbb = file (t_proc)
    dim i2 as integer, c2 as integer
    c2 = sbb.Count
    if c2 > 0 then
    for i2 = 0 to c2 - 1
        fprint f, sbb.item (i2), ""
    next
    end if
    fprint f, "\n"
    delete sbb

    dim byref sbb2 as StringBuffer
    set sbb2 = new StringBuffer ()
    sbb2 = file (t_logic)
    dim i3 as integer, c3 as integer
    c3 = sbb2.Count
    if c3 > 0 then
    for i3 = 0 to c3 - 1
        fprint f, sbb2.item (i3), ""
    next
    end if
    fprint f, "\n"
    delete sbb2


    fprint f, "    if hit = ACTION_FINISH then\n"
    fprint f, "       " + "Act_Step = Act_Step + 1" + "\n"
    fprint f, "       " + "GoFinish()" + "\n"
    fprint f, "       " + "hit = 0" + "\n"
    fprint f, "    end if\n"

    fprint f, "    if hit = ACTION_NEXT then\n"
    fprint f, "       " + "Act_Step = Act_Step + 1" + "\n"
    fprint f, "       " + "if decision then" + "\n"
    fprint f, "           " + t_t + "\n"
    fprint f, "       " + "else" + "\n"
    fprint f, "           " + t_f + "\n"
    fprint f, "       " + "end if" + "\n"
    fprint f, "       " + "hit = 0" + "\n"
    fprint f, "    end if\n"
    fprint f, "    if hit = ACTION_BACK then \n"
    fprint f, "       " + "Act_Step = Act_Step - 1" + "\n"
    fprint f, "       exit do\n"
    fprint f, "    end if\n"
    fprint f, "loop\n"
    fprint f, "end sub\n"



    'fprint f, "dim ", trim(t_var.get ("Name")), " as ", trim(t_var.get ("Type")), " = ", df, "\n"
    if t_act.eof then exit do
    t_act.next
  loop


  fprint f, "sub main\n"
  t_act.cursor = 1
  do
    dim t_action as string = trim(t_act.getstr ("Action"))
    dim t_form as string = trim(t_act.getstr("Form"))
    fprint f, "    FormExists (\'"+t_action+"\')\n"
    if t_act.eof then exit do
    t_act.next
  loop

  fprint f, "    start_expert()\n"
  fprint f, "    ExpertForm.Caption = \'" + t_Set.GetStr ("ProjectName") + "\'\n"
  fprint f, "    do\n"
  fprint f, "    " + t_start_action + "\n"
  fprint f, "    msgbox \'   , .     \'\n"
  fprint f, "    Act_Step = Act_Step + 1\n"
  fprint f, "    loop\n"

  fprint f, "end sub\n"



 fclose (f)

  fb.Comment.Caption = " " + FileNameEXE + " ..." 
  fb.COmment.Refresh()

 shell "del " + FileNameEXE

 'WinExec "del " + FileNameEXE, 10
 'WinExec "pb Code.bas Code.unit > error.txt", 10
 shell "pb Code.bas Code.unit > error.txt" 
 'WinExec "plink /r:winguistatic Code.unit " + FileNameEXE + " >> error.txt", 10
 shell "plink /r:winguistatic Code.unit " + FileNameEXE + " >> error.txt"
 'WinExec "if not exist " + FileNameEXE + " notepad error.txt", 10
 shell "if not exist " + FileNameEXE + " notepad error.txt"
 'shell "del code.bas"
 shell "del code.unit"
 shell "del error.txt"



end sub

end class