'* 
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved  
'*
'*
unit lang.StringBuffer

$document "../../../doc/StringBuffer.htm"


import lang.collection
     
'*
'*   .
'*
class StringBuffer: implements Collection()

      '**
      '*  
      '*
      sub Add ( byval nString as string )
      
          dim byref s as string
          set s = new string
          s = nString
        
          this::Add ( ref s )
      
      end sub
      

      sub Set ( byval Index as integer, byval NewString as string )

       if ( Index >= 0 ) and ( Index < this.Count() ) then
         dim byref s as string
         set s = this::item ( index )
         s = NewString
       end if

      end sub

      '**
      '*     Index   () 
      '*
      function Item ( byval Index as integer ) as string
      
       if ( Index >= 0 ) and ( Index < this.Count() ) then
         dim byref s as string
         set s = this::item ( index )
         return = s
       end if
      
      end function
      
    
      '**
      '*  ,    , -1    
      '*
      function IndexOf ( byval Str as string ) as integer
        return = -1
        dim i as integer, c as integer
        c = this.Count
        if c > 0 then
           for i = 0 to c -1 
              if lcase (this.item(i)) = lcase(str) then 
                 return = i : exit for
              end if
           next
        end if
      end function
  

      '**
      '* - 
      '*
      function Count () as integer
     
          return = this::count()
      
      end function

      '**
      '*  
      '*
      private sub DelStrings ()
      dim i as integer, c as integer
      
        c = this.count()
        if c > 0 then
        for i = 0 to c-1
        
            dim byref s as string
            set s = this::item (i)
            'msgbox str(c)+"  " + s
            delete s
    
        next
        end if
      end sub
      
      '**
      '* 
      '*
      public sub Clear ()
      
        this.DelStrings()
        this::Clear()
      
      end sub
      
      '**
      '* 
      '*
      declare sub StringBuffer ()

      '**
      '* 
      '*
      sub Finalize ()

        'msgbox "StringBufferFinalize"
        '  
        this.DelStrings

      end sub



end class

sub StringBuffer.StringBuffer()
    this.DelStrings
end sub

function Explode ( byval str as string, byval Separator as string ) as StringBuffer
dim i as integer, c as integer
dim start as integer = 0
dim s as string
dim lpos as integer = 0
dim go as boolean = false


    do
      start = InStr (start, str, Separator, 0, false)

      'print start
      if start = -1 then 
         go = true
      else
         go = true
      end if

      if go = true then
         s = mid(str, lpos, start-lpos)
         'print s
         go = false
         return.add (s)

      end if

      if start = -1 then exit do
      start = start + 1
      lpos = start
    loop

end function



sub InitLibrary

end sub

sub ReleaseLibrary

end sub