'*                                                                              
'*  FILESYSTEM.BAS - Force Basic Module                                         
'*                                                                              
'*  Copyright(c) 2005 by Metlashevskiy Egor. All right reserved                 
'*                                                                              
'*
'*  䠩 ⥬.   ᮢ⨬  Windows  DOS
'*
'*

$ifndef _FILESYSTEM_BAS
$define _FILESYSTEM_BAS

typedef FILE as pointer


const _SEEK_SET = 0
const _SEEK_CUR = 1
const _SEEK_END = 2

function fopen (byval FileName as string, byval Mode as string) as FILE: asm sys 69: end function
function fgets (byval Stream as FILE, byval Count as integer) as string: asm sys 70: end function
function fgetc (byval Stream as FILE) as integer: asm sys 71: end function
function fclose (byval Stream as FILE) as integer: asm sys 72: end function
function feof (byval Stream as FILE) as integer: asm sys 73: end function
function fread (byval Stream as FILE, byval Count as integer) as string: asm sys 74: end function
function fputs (byval Stream as FILE, byval Chars as string) as integer: asm sys 75: end function
function fputc (byval Stream as FILE, byval Char as integer) as integer: asm sys 76: end function
function fwrite (byval Stream as FILE, byval Chars as string) as integer: asm sys 77: end function
function ftell (byval Steram as FILE) as integer: asm sys 78: end function
function fseek (byval Stream as FILE, byval Offset as integer, byval Whence as integer) as integer: asm sys 79: end function
function fremove (byval FileName as string) as integer: asm sys 80: end function
function frename (byval OldFileName as string, byval NewFileName as string) as integer: asm sys 81: end function
function ftmpnam () as string: asm sys 82: end function
function ftmpfile () as FILE: asm sys 83: end function
function chdir (byval Path as string) as integer: asm sys 85: end function
function rmdir (byval Path as string) as integer: asm sys 86: end function
function mkdir (byval Path as string) as integer: asm sys 87: end function
function getcwd () as string: asm sys 88: end function



public sub fprints (byval Stream as FILE, byval String as string)
  'asm push dd ptr ebp+8   '࠭  ப  
  'asm con 0           
  '᮫쭠 㭪  ⮡ࠦ ᨬ 
  fwrite stream, string
  'print "asd"
end sub


public sub fprint (...)
dim i as dword
dim byref pString as string
dim byref pSmall as small
dim byref pByte as byte
dim byref pWord as word
dim byref pShort as short
dim byref pDWord as dword
dim byref pLong as long
dim byref pSingle as single
dim byref pDouble as double
dim byref pExtendet as extendet
dim pText as string
dim argType as byte
dim pPointer as dword
dim byref hFile as FILE

 'if ArgCount > 1 then

    set hFile = Arguments(0).ptr
    for i = 1 to ArgCount - 1
      argType = Arguments(i).argType
      select case argType
      case tpSMALL:
        set pSmall = Arguments(i).ptr
        fprints hFile, str$(pSmall)
      case tpBYTE:
        set pByte = Arguments(i).ptr
        fprints hFile, str$(pByte)
      case tpWORD:
        set pWord = Arguments(i).ptr
        fprints hFile, str$(pWord)
      case tpSHORT:
        set pShort = Arguments(i).ptr
        fprints hFile, str$(pShort)
      case tpDWORD:
        set pDWord = Arguments(i).ptr
        fprints hFile, str$(pDWord)
      case tpLONG:
        set pLong = Arguments(i).ptr
        fprints hFile, str$(pLong)
      case tpSINGLE:
        set pSingle = Arguments(i).ptr
        fprints hFile, str$(pSingle)
      case tpDOUBLE:
        set pDouble = Arguments(i).ptr
        fprints hFile, str$(pDouble)
      case tpEXTENDET:
        set pExtendet = Arguments(i).ptr
        fprints hFile, str$(pExtendet)
      case tpSTRING:
        set pString = Arguments(i).ptr
        fprints hFile, pString
      case else:
        fprints hFile, "[UnknownType]"  '  ⨯ 
      end select
    next

  'end if
end sub


'sub InitLibrary
'end sub

'sub ReleaseLibrary
'end sub

$endif