;-----------------------------------------------------------------
;
;  Filename - System.asm
;
;  This file grows out assemblage of a file: System.bas 
;  
;  RTL Library: win32.rtl
;  
;
;  Copyright(c) 2005 by Metlashevskiy Egor
;  All Rights Reserved.
;
;-----------------------------------------------------------------

public Argument_GetString@F
public Argument_GetNumber@E
public Argument_isNumber@B
public Argument_isString@C
public Argument_isUnknown@D
public Str@EE
public Str@EF
public Val@EG
public Oct@EH
public Hex@EI
public Asc@EJ
public Chr@FA
public Trim@FB
public RTrim@FC
public LTrim@FD
public LCase@FE
public UCase@FF
public Left@FG
public Right@FH
public Mid@FI
public Mid@FJ
public Space@GA
public Len@GB
public InStr@GC
public StrReplace@GD
public MemCpy@GJ
public MemCmp@HA
public MemSet@HB
public StrCpy@HC
public StrCmp@HD
public StrCat@HE
public StrLwr@HF
public StrUpr@HG
public StrColl@HH
public StrLen@HI
public StrICmp@HJ
public StrIColl@IA
public CharToStr@IB
public StrCpy@IC
public StrCat@ID
public Rnd@IE
public Random@IF
public Randomize@IG
public Abs@IH
public Atn@II
public Cos@IJ
public Exp@JA
public Log@JB
public Sin@JC
public Sqr@JD
public Sgn@JE
public Floor@JF
public Ceil@JG
public ACos@JH
public ASin@JI
public Tan@JJ
public Log10@BAA
public fopen@BAB
public fgets@BAC
public fgetc@BAD
public fclose@BAE
public feof@BAF
public fread@BAG
public fputs@BAH
public fputc@BAI
public fwrite@BAJ
public ftell@BBA
public fseek@BBB
public fremove@BBC
public frename@BBD
public ftmpnam@BBE
public ftmpfile@BBF
public chdir@BBG
public rmdir@BBH
public mkdir@BBI
public getcwd@BBJ
public fprints@BCA
public fprint@BCB
public Resource_LF@BEG
public Resource_GetSize@BEH
public Resource_GetPtr@BEI
public Resource_GetTextData@BEJ
public Exit@BFD
public Exit@BFE
public mAlloc@BFF
public mFree@BFG
public DeleteClass@BFH
public Shell@BFI
public ParamCount@BFJ
public ParamStr@BGA
public Command@BGB
public Environ@BGC
public GetCallBackEventPtr@BGD
public AddressOf@BGE
public VirtualOf@BGF
public DoEvents@BGG
public ReturnEAX@BGH
public _vm_info@BGI
private set_sys_event@BGJ
private get_sys_event@BHA
private get_err_code@BHB
public Runable_ErrCode@BHE
public Runable_ErrDesc@BHF
public Runable_Version@BIC
public Runable_ByteCodeSize@BID
public Runable_Title@BIE
public Runable_DLL_Count@BIF
public Runable_DLL_Proc_Count@BIG
public Runable_StackSize@BIH
public Runable_StackSpace@BII
public Runable_OnError@BHC
public Runable_OnError@BHD
public Runable
public InitLibrary_System_basBJC
public ReleaseLibrary_System_basBJD

data_ segment DATA BYTE PRIVATE
        Runable db 0 DUP (?)
data_ ends

code_ segment CODE BYTE PRIVATE
        mov eax, ebx 

Argument_GetString@F proc

        enter 8
        ms dd ptr esp
        enter 4
        mov edi, dword ptr ebp+12
        mov dd ptr esp, edi
        add dd ptr esp, dd 4
        enter 1
        mov st1, dd ptr esp+1
        ce db ptr st1, dd 9, db ptr esp
        jmp db ptr esp, local@I
        jmp local@J
local@I:
        enter 4
        mov st2, dword ptr ebp+12
        mov dd ptr esp, st2
        mov esi, dd ptr esp
        mov dd ptr esp+13, dd ptr esi
        mov edi, dd ptr esp+13
        movs dd ptr esp+9, dd ptr edi
        leave 4
        jmp lendif@B
local@J:
        mov dd ptr esp+5, ""
lendif@B:
local@BA:
        mov st1, dd ptr ebp+8
        movs dd ptr st1, dd ptr esp+5
        rs dd ptr esp+5
        leave 13
        retp 0

Argument_GetString@F endp


Argument_GetNumber@E proc

        enter 53
        mov st2, dword ptr ebp+12
        mov dd ptr esp, st2
        add dd ptr esp, dd 4
        mov esi, dd ptr esp
        mov db ptr esp+4, db ptr esi
        enter 4
        mov edi, dword ptr ebp+12
        mov dd ptr esp, edi
        mov st1, dd ptr esp
        mov dd ptr esp+17, dd ptr st1
        enter 1
        ce db ptr esp+9, dd 0, db ptr esp
        jmp db ptr esp, local@BD
        jmp local@BC
local@BD:
        mov dd ptr esp+54, dd ptr esp+18
        mov st2, dd ptr esp+54
        mov dq ptr esp+10, small ptr st2
        leave 1
        jmp lendsct@B
local@BC:
        leave 1
        enter 1
        ce db ptr esp+9, dd 1, db ptr esp
        jmp db ptr esp, local@BF
        jmp local@BE
local@BF:
        mov dd ptr esp+50, dd ptr esp+18
        mov esi, dd ptr esp+50
        mov dq ptr esp+10, db ptr esi
        leave 1
        jmp lendsct@B
local@BE:
        leave 1
        enter 1
        ce db ptr esp+9, dd 3, db ptr esp
        jmp db ptr esp, local@BH
        jmp local@BG
local@BH:
        mov dd ptr esp+46, dd ptr esp+18
        mov edi, dd ptr esp+46
        mov dq ptr esp+10, dw ptr edi
        leave 1
        jmp lendsct@B
local@BG:
        leave 1
        enter 1
        ce db ptr esp+9, dd 2, db ptr esp
        jmp db ptr esp, local@BJ
        jmp local@BI
local@BJ:
        mov dd ptr esp+42, dd ptr esp+18
        mov st1, dd ptr esp+42
        mov dq ptr esp+10, short ptr st1
        leave 1
        jmp lendsct@B
local@BI:
        leave 1
        enter 1
        ce db ptr esp+9, dd 4, db ptr esp
        jmp db ptr esp, local@CB
        jmp local@CA
local@CB:
        mov dd ptr esp+38, dd ptr esp+18
        mov st2, dd ptr esp+38
        mov dq ptr esp+10, dd ptr st2
        leave 1
        jmp lendsct@B
local@CA:
        leave 1
        enter 1
        ce db ptr esp+9, dd 5, db ptr esp
        jmp db ptr esp, local@CD
        jmp local@CC
local@CD:
        mov dd ptr esp+34, dd ptr esp+18
        mov esi, dd ptr esp+34
        mov dq ptr esp+10, long ptr esi
        leave 1
        jmp lendsct@B
local@CC:
        leave 1
        enter 1
        ce db ptr esp+9, dd 6, db ptr esp
        jmp db ptr esp, local@CF
        jmp local@CE
local@CF:
        mov dd ptr esp+30, dd ptr esp+18
        mov edi, dd ptr esp+30
        mov dq ptr esp+10, df ptr edi
        leave 1
        jmp lendsct@B
local@CE:
        leave 1
        enter 1
        ce db ptr esp+9, dd 7, db ptr esp
        jmp db ptr esp, local@CH
        jmp local@CG
local@CH:
        mov dd ptr esp+26, dd ptr esp+18
        mov st1, dd ptr esp+26
        mov dq ptr esp+10, dq ptr st1
        leave 1
        jmp lendsct@B
local@CG:
        leave 1
        enter 1
        ce db ptr esp+9, dd 8, db ptr esp
        jmp db ptr esp, local@CJ
        jmp local@CI
local@CJ:
        mov dd ptr esp+22, dd ptr esp+18
        mov st2, dd ptr esp+22
        mov dq ptr esp+10, dt ptr st2
        leave 1
        jmp lendsct@B
local@DA:
        mov dq ptr esp+10, db 0
        leave 1
        jmp lendsct@B
local@CI:
        leave 1
        jmp local@DA
lendsct@B:
        mov esi, dd ptr ebp+8
        mov dq ptr esi, dq ptr esp+9
        leave 57
        retp 0

Argument_GetNumber@E endp


Argument_isNumber@B proc

        enter 4
        mov edi, dword ptr ebp+12
        mov dd ptr esp, edi
        add dd ptr esp, dd 4
        enter 4
        mov st1, dword ptr ebp+12
        mov dd ptr esp, st1
        add dd ptr esp, dd 4
        enter 1
        mov st2, dd ptr esp+5
        cae db ptr st2, db 0, db ptr esp
        enter 1
        mov esi, dd ptr esp+2
        cbe db ptr esi, db 8, db ptr esp
        enter 1
        mov db ptr esp, db ptr esp+2
        and db ptr esp, db ptr esp+1
        jmp db ptr esp, local@DD
        jmp local@DE
local@DD:
        mov edi, dd ptr ebp+8
        mov db ptr edi, db 1
        jmp lendif@C
local@DE:
        mov st1, dd ptr ebp+8
        mov db ptr st1, db 0
lendif@C:
local@DF:
        leave 11
        retp 0

Argument_isNumber@B endp


Argument_isString@C proc

        enter 4
        mov st2, dword ptr ebp+12
        mov dd ptr esp, st2
        add dd ptr esp, dd 4
        enter 1
        mov esi, dd ptr esp+1
        ce db ptr esi, dd 9, db ptr esp
        jmp db ptr esp, local@DH
        jmp local@DI
local@DH:
        mov edi, dd ptr ebp+8
        mov db ptr edi, db 1
        jmp lendif@D
local@DI:
        mov st1, dd ptr ebp+8
        mov db ptr st1, db 0
lendif@D:
local@DJ:
        leave 5
        retp 0

Argument_isString@C endp


Argument_isUnknown@D proc

        enter 4
        mov st2, dword ptr ebp+12
        mov dd ptr esp, st2
        add dd ptr esp, dd 4
        enter 1
        mov esi, dd ptr esp+1
        ce db ptr esi, dd 255, db ptr esp
        jmp db ptr esp, local@EB
        jmp local@EC
local@EB:
        mov edi, dd ptr ebp+8
        mov db ptr edi, db 1
        jmp lendif@E
local@EC:
        mov st1, dd ptr ebp+8
        mov db ptr st1, db 0
lendif@E:
local@ED:
        leave 5
        retp 0

Argument_isUnknown@D endp


Str@EE proc

        sys 0
        retp 8

Str@EE endp


Str@EF proc

        sys 39
        retp 4

Str@EF endp


Val@EG proc

        sys 1
        retp 4

Val@EG endp


Oct@EH proc

        sys 2
        retp 4

Oct@EH endp


Hex@EI proc

        sys 3
        retp 4

Hex@EI endp


Asc@EJ proc

        sys 5
        retp 4

Asc@EJ endp


Chr@FA proc

        sys 6
        retp 1

Chr@FA endp


Trim@FB proc

        sys 7
        retp 4

Trim@FB endp


RTrim@FC proc

        sys 8
        retp 4

RTrim@FC endp


LTrim@FD proc

        sys 9
        retp 4

LTrim@FD endp


LCase@FE proc

        sys 10
        retp 4

LCase@FE endp


UCase@FF proc

        sys 11
        retp 4

UCase@FF endp


Left@FG proc

        sys 12
        retp 8

Left@FG endp


Right@FH proc

        sys 13
        retp 8

Right@FH endp


Mid@FI proc

        sys 14
        retp 12

Mid@FI endp


Mid@FJ proc

        sys 15
        retp 8

Mid@FJ endp


Space@GA proc

        sys 16
        retp 4

Space@GA endp


Len@GB proc

        sys 17
        retp 4

Len@GB endp


InStr@GC proc

        sys 40
        retp 17

InStr@GC endp


StrReplace@GD proc

        enter 12
        ms dd ptr esp
        enter 4
        ms dd ptr esp
        mov dd ptr esp, ""
        enter 4
        mov dd ptr esp, dd 0
        lva st2, dd ptr esp
        push st2
        push dd ptr ebp+8
        call Len@GB
        mov long ptr esp+16, dd ptr esp+4
        mov long ptr esp+20, db 0
StrReplace@GD@GE:
        enter 1
        
        ca long ptr esp+21, long ptr esp+17, db ptr esp
        jmp db ptr esp, StrReplace@GD@GF
        enter 4
        ms dd ptr esp
        lva esi, dd ptr esp
        push esi
        enter 4
        mov long ptr esp, long 1
        push long ptr esp+33
        push dd ptr ebp+8
        call Mid@FI
        movs dd ptr esp+21, dd ptr esp+4
        ces ah, dd ptr ebp+12, dd ptr esp+21
        jmp ah, local@GG
        jmp local@GH
local@GG:
        enter 4
        ms dd ptr esp
        movs dd ptr esp, dd ptr esp+21
        adds dd ptr esp, dd ptr ebp+16
        movs dd ptr esp+21, dd ptr esp
        rs dd ptr esp
        leave 4
        jmp lendif@F
local@GH:
        enter 4
        ms dd ptr esp
        movs dd ptr esp, dd ptr esp+21
        adds dd ptr esp, dd ptr esp+25
        movs dd ptr esp+21, dd ptr esp
        rs dd ptr esp
        leave 4
lendif@F:
local@GI:
        enter 4
        mov long ptr esp, long ptr esp+33
        inc long ptr esp
        mov long ptr esp+33, long ptr esp
        rs dd ptr esp+8
        leave 13
        jmp StrReplace@GD@GE
StrReplace@GD@GF:
        leave 1
        mov edi, dd ptr ebp+20
        movs dd ptr edi, dd ptr esp+8
        rs dd ptr esp+12
        rs dd ptr esp+8
        leave 24
        retp 12

StrReplace@GD endp


MemCpy@GJ proc

        sys 18
        retp 12

MemCpy@GJ endp


MemCmp@HA proc

        sys 19
        retp 12

MemCmp@HA endp


MemSet@HB proc

        sys 20
        retp 9

MemSet@HB endp


StrCpy@HC proc

        sys 26
        retp 8

StrCpy@HC endp


StrCmp@HD proc

        sys 27
        retp 8

StrCmp@HD endp


StrCat@HE proc

        sys 28
        retp 8

StrCat@HE endp


StrLwr@HF proc

        sys 29
        retp 4

StrLwr@HF endp


StrUpr@HG proc

        sys 30
        retp 4

StrUpr@HG endp


StrColl@HH proc

        sys 31
        retp 8

StrColl@HH endp


StrLen@HI proc

        sys 32
        retp 4

StrLen@HI endp


StrICmp@HJ proc

        sys 33
        retp 8

StrICmp@HJ endp


StrIColl@IA proc

        sys 34
        retp 8

StrIColl@IA endp


CharToStr@IB proc

        sys 35
        retp 4

CharToStr@IB endp


StrCpy@IC proc

        sys 36
        retp 8

StrCpy@IC endp


StrCat@ID proc

        sys 37
        retp 8

StrCat@ID endp


Rnd@IE proc

        sys 45
        retp 0

Rnd@IE endp


Random@IF proc

        sys 46
        retp 4

Random@IF endp


Randomize@IG proc

        sys 47
        retp 4

Randomize@IG endp


Abs@IH proc

        sys 48
        retp 4

Abs@IH endp


Atn@II proc

        sys 49
        retp 8

Atn@II endp


Cos@IJ proc

        sys 50
        retp 8

Cos@IJ endp


Exp@JA proc

        sys 51
        retp 8

Exp@JA endp


Log@JB proc

        sys 52
        retp 8

Log@JB endp


Sin@JC proc

        sys 53
        retp 8

Sin@JC endp


Sqr@JD proc

        sys 54
        retp 8

Sqr@JD endp


Sgn@JE proc

        sys 55
        retp 8

Sgn@JE endp


Floor@JF proc

        sys 56
        retp 8

Floor@JF endp


Ceil@JG proc

        sys 57
        retp 8

Ceil@JG endp


ACos@JH proc

        sys 58
        retp 8

ACos@JH endp


ASin@JI proc

        sys 59
        retp 8

ASin@JI endp


Tan@JJ proc

        sys 60
        retp 8

Tan@JJ endp


Log10@BAA proc

        sys 61
        retp 8

Log10@BAA endp


fopen@BAB proc

        sys 69
        retp 8

fopen@BAB endp


fgets@BAC proc

        sys 70
        retp 8

fgets@BAC endp


fgetc@BAD proc

        sys 71
        retp 4

fgetc@BAD endp


fclose@BAE proc

        sys 72
        retp 4

fclose@BAE endp


feof@BAF proc

        sys 73
        retp 4

feof@BAF endp


fread@BAG proc

        sys 74
        retp 8

fread@BAG endp


fputs@BAH proc

        sys 75
        retp 8

fputs@BAH endp


fputc@BAI proc

        sys 76
        retp 8

fputc@BAI endp


fwrite@BAJ proc

        sys 77
        retp 8

fwrite@BAJ endp


ftell@BBA proc

        sys 78
        retp 4

ftell@BBA endp


fseek@BBB proc

        sys 79
        retp 12

fseek@BBB endp


fremove@BBC proc

        sys 80
        retp 4

fremove@BBC endp


frename@BBD proc

        sys 81
        retp 8

frename@BBD endp


ftmpnam@BBE proc

        sys 82
        retp 0

ftmpnam@BBE endp


ftmpfile@BBF proc

        sys 83
        retp 0

ftmpfile@BBF endp


chdir@BBG proc

        sys 85
        retp 4

chdir@BBG endp


rmdir@BBH proc

        sys 86
        retp 4

rmdir@BBH endp


mkdir@BBI proc

        sys 87
        retp 4

mkdir@BBI endp


getcwd@BBJ proc

        sys 88
        retp 0

getcwd@BBJ endp


fprints@BCA proc

        enter 4
        mov dd ptr esp, dd 0
        mov dd ptr esp, dd ptr ebp+8
        enter 4
        mov long ptr esp, long 0
        lva st1, long ptr esp
        push st1
        push dd ptr ebp+12
        push dd ptr esp+12
        call fwrite@BAJ
        leave 12
        retp 8

fprints@BCA endp


fprint@BCB proc

        enter 48
        ms dd ptr esp
        enter 9
        mov dd ptr esp, dd ptr ebp+12
        mov dd ptr esp+53, db 1
fprint@BCB@BCC:
        enter 4
        mov long ptr esp, long ptr ebp+8
        sub long ptr esp, db 1
        enter 1
        
        ca dd ptr esp+58, long ptr esp+1, db ptr esp
        jmp db ptr esp, fprint@BCB@BCD
        enter 4
        mov dd ptr esp, dd ptr esp+62
        mul dd ptr esp, dd 5
        mov eax, dd 0
        enter 4
        mov dd ptr esp, eax
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 4
        mov st2, dd ptr esp
        mov db ptr esp+25, db ptr ebp+st2+12
        enter 1
        ce db ptr esp+26, dd 0, db ptr esp
        jmp db ptr esp, local@BCF
        jmp local@BCE
local@BCF:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+75, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+79
        mov long ptr esp, small ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BCE:
        leave 1
        enter 1
        ce db ptr esp+26, dd 1, db ptr esp
        jmp db ptr esp, local@BCH
        jmp local@BCG
local@BCH:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+71, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+75
        mov long ptr esp, db ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BCG:
        leave 1
        enter 1
        ce db ptr esp+26, dd 3, db ptr esp
        jmp db ptr esp, local@BCJ
        jmp local@BCI
local@BCJ:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+67, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+71
        mov long ptr esp, dw ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BCI:
        leave 1
        enter 1
        ce db ptr esp+26, dd 2, db ptr esp
        jmp db ptr esp, local@BDB
        jmp local@BDA
local@BDB:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+63, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+67
        mov long ptr esp, short ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BDA:
        leave 1
        enter 1
        ce db ptr esp+26, dd 4, db ptr esp
        jmp db ptr esp, local@BDD
        jmp local@BDC
local@BDD:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+59, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+63
        mov long ptr esp, dd ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BDC:
        leave 1
        enter 1
        ce db ptr esp+26, dd 5, db ptr esp
        jmp db ptr esp, local@BDF
        jmp local@BDE
local@BDF:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+55, dd ptr ebp+esi+12
        enter 4
        ms dd ptr esp
        lva edi, dd ptr esp
        push edi
        mov st1, dd ptr esp+63
        push long ptr st1
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+42
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 12
        leave 12
        leave 1
        jmp lendsct@C
local@BDE:
        leave 1
        enter 1
        ce db ptr esp+26, dd 6, db ptr esp
        jmp db ptr esp, local@BDH
        jmp local@BDG
local@BDH:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+51, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+55
        mov long ptr esp, df ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BDG:
        leave 1
        enter 1
        ce db ptr esp+26, dd 7, db ptr esp
        jmp db ptr esp, local@BDJ
        jmp local@BDI
local@BDJ:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+47, dd ptr ebp+esi+12
        enter 4
        ms dd ptr esp
        lva edi, dd ptr esp
        push edi
        mov st1, dd ptr esp+55
        push dq ptr st1
        call Str@EE
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+42
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 12
        leave 12
        leave 1
        jmp lendsct@C
local@BDI:
        leave 1
        enter 1
        ce db ptr esp+26, dd 8, db ptr esp
        jmp db ptr esp, local@BEB
        jmp local@BEA
local@BEB:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+43, dd ptr ebp+esi+12
        enter 4
        mov long ptr esp, long 0
        mov edi, dd ptr esp+47
        mov long ptr esp, dt ptr edi
        enter 4
        ms dd ptr esp
        lva st1, dd ptr esp
        push st1
        push long ptr esp+8
        call Str@EF
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+46
        mov dd ptr esp, dd ptr st2
        push dd ptr esp+8
        push dd ptr esp+4
        call fprints@BCA
        rs dd ptr esp+8
        leave 16
        leave 12
        leave 1
        jmp lendsct@C
local@BEA:
        leave 1
        enter 1
        ce db ptr esp+26, dd 9, db ptr esp
        jmp db ptr esp, local@BED
        jmp local@BEC
local@BED:
        enter 4
        mov dd ptr esp, dd ptr esp+75
        mul dd ptr esp, dd 5
        mov ebx, dd 0
        enter 4
        mov dd ptr esp, ebx
        add dd ptr esp, dd ptr esp+4
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, dd 0
        mov esi, dd ptr esp
        mov dd ptr esp+79, dd ptr ebp+esi+12
        enter 4
        mov dd ptr esp, dd 0
        mov edi, dd ptr esp+34
        mov dd ptr esp, dd ptr edi
        mov st1, dd ptr esp+83
        push dd ptr st1
        push dd ptr esp+4
        call fprints@BCA
        leave 4
        leave 12
        leave 1
        jmp lendsct@C
local@BEE:
        enter 4
        mov dd ptr esp, dd 0
        mov st2, dd ptr esp+22
        mov dd ptr esp, dd ptr st2
        enter 4
        ms dd ptr esp
        mov dd ptr esp, "[UnknownType]"
        push dd ptr esp
        push dd ptr esp+8
        call fprints@BCA
        rs dd ptr esp
        rs dd ptr esp
        leave 8
        leave 1
        jmp lendsct@C
local@BEC:
        leave 1
        jmp local@BEE
lendsct@C:
        enter 4
        mov dd ptr esp, dd ptr esp+74
        inc dd ptr esp
        mov dd ptr esp+74, dd ptr esp
        leave 21
        jmp fprint@BCB@BCC
fprint@BCB@BCD:
        leave 5
        rs dd ptr esp+9
        leave 57
        retp 0

fprint@BCB endp


Resource_LF@BEG proc

        enter 4
        mov esi, dword ptr ebp+16
        mov dd ptr esp, esi
        mov edi, dd ptr esp
        mov st1, dd ptr ebp+8
        mov dd ptr edi, dd ptr st1
        leave 4
        retp 4

Resource_LF@BEG endp


Resource_GetSize@BEH proc

        enter 4
        mov st2, dword ptr ebp+12
        mov dd ptr esp, st2
        mov esi, dd ptr ebp+8
        mov edi, dd ptr esp
        mov dd ptr esi, dd ptr edi
        leave 4
        retp 0

Resource_GetSize@BEH endp


Resource_GetPtr@BEI proc

        enter 4
        mov dd ptr esp, dd 0
        mov st1, dword ptr ebp+12
        mov dd ptr esp, st1
        enter 4
        mov dd ptr esp, dd ptr esp+4
        add dd ptr esp, db 4
        mov st2, dd ptr ebp+8
        mov dd ptr st2, dd ptr esp
        leave 8
        retp 0

Resource_GetPtr@BEI endp


Resource_GetTextData@BEJ proc

        enter 4
        mov esi, dword ptr ebp+12
        mov dd ptr esp, esi
        enter 1
        mov edi, dd ptr esp+1
        cne dd ptr edi, db 0, db ptr esp
        jmp db ptr esp, local@BFA
        jmp local@BFB
local@BFA:
        enter 8
        mov dd ptr esp, dd 0
        mov st1, dword ptr ebp+12
        push st1
        lva st2, dd ptr esp+4
        push st2
        call Resource_GetPtr@BEI
        mov dd ptr esp+12, dd ptr esp+8
        enter 4
        mov dd ptr esp, dd 0
        mov esi, dd ptr esp+16
        mov dd ptr esp, dd ptr esi
        enter 4
        ms dd ptr esp
        lva edi, dd ptr esp
        push edi
        push dd ptr esp+8
        call CharToStr@IB
        mov st1, dd ptr ebp+8
        movs dd ptr st1, dd ptr esp+4
        rs dd ptr esp+4
        leave 28
lendif@G:
local@BFB:
        leave 5
        retp 0

Resource_GetTextData@BEJ endp


Exit@BFD proc

        mov eax, dd ptr ebp+8
        exit
        retp 4

Exit@BFD endp


Exit@BFE proc

        mov eax, 0
        exit
        retp 0

Exit@BFE endp


mAlloc@BFF proc

        new eax, dd ptr ebp+8
        mov esi, dd ptr ebp+12
        mov dd ptr esi, eax
        retp 4

mAlloc@BFF endp


mFree@BFG proc

        del dd ptr ebp+8
        retp 4

mFree@BFG endp


DeleteClass@BFH proc

        sys 63
        retp 4

DeleteClass@BFH endp


Shell@BFI proc

        sys 84
        retp 4

Shell@BFI endp


ParamCount@BFJ proc

        sys 21
        retp 0

ParamCount@BFJ endp


ParamStr@BGA proc

        sys 22
        retp 4

ParamStr@BGA endp


Command@BGB proc

        sys 23
        retp 0

Command@BGB endp


Environ@BGC proc

        sys 24
        retp 4

Environ@BGC endp


GetCallBackEventPtr@BGD proc

        sys 25
        retp 0

GetCallBackEventPtr@BGD endp


AddressOf@BGE proc

        push eax
        push ebx
        lpa eax, dd ptr ebp+8
        mov ebx, dd ptr ebp+12
        mov dd ptr ebx, eax
        pop ebx
        pop eax
        retp 4

AddressOf@BGE endp


VirtualOf@BGF proc

        sys 38
        retp 4

VirtualOf@BGF endp


DoEvents@BGG proc

        sys 66
        retp 0

DoEvents@BGG endp


ReturnEAX@BGH proc

        sys 103
        retp 4

ReturnEAX@BGH endp


_vm_info@BGI proc

        sys 104
        retp 4

_vm_info@BGI endp


set_sys_event@BGJ proc

        sys 100
        retp 8

set_sys_event@BGJ endp


get_sys_event@BHA proc

        sys 101
        retp 4

get_sys_event@BHA endp


get_err_code@BHB proc

        sys 102
        retp 0

get_err_code@BHB endp


Runable_ErrCode@BHE proc

        enter 4
        mov dd ptr esp, dd 0
        lva st2, dd ptr esp
        push st2
        call get_err_code@BHB
        mov esi, dd ptr ebp+8
        mov dd ptr esi, dd ptr esp+4
        leave 8
        retp 0

Runable_ErrCode@BHE endp


Runable_ErrDesc@BHF proc

        enter 4
        mov dd ptr esp, dd 0
        mov edi, dword ptr ebp+12
        push edi
        lva st1, dd ptr esp+4
        push st1
        call Runable_ErrCode@BHE
        enter 4
        mov dd ptr esp, dd ptr esp+12
        enter 1
        ce dd ptr esp+1, db 1, db ptr esp
        jmp db ptr esp, local@BHG
        jmp local@BHH
local@BHG:
        mov st2, dd ptr ebp+8
        mov dd ptr st2, "Access validation"
local@BHH:
        enter 1
        ce dd ptr esp+2, word 1000, db ptr esp
        jmp db ptr esp, local@BHI
        jmp local@BHJ
local@BHI:
        mov esi, dd ptr ebp+8
        mov dd ptr esi, "Stack overflow"
local@BHJ:
        enter 1
        ce dd ptr esp+3, word 1001, db ptr esp
        jmp db ptr esp, local@BIA
        jmp local@BIB
local@BIA:
        mov edi, dd ptr ebp+8
        mov dd ptr edi, "Declare(s) no correct"
local@BIB:
        leave 19
        retp 0

Runable_ErrDesc@BHF endp


Runable_Version@BIC proc

        enter 4
        mov long ptr esp, long 0
        lva st1, long ptr esp
        push st1
        enter 4
        mov long ptr esp, long 0
        call _vm_info@BGI
        mov st2, dd ptr ebp+8
        mov long ptr st2, long ptr esp+4
        leave 8
        retp 0

Runable_Version@BIC endp


Runable_ByteCodeSize@BID proc

        enter 4
        mov long ptr esp, long 0
        lva esi, long ptr esp
        push esi
        enter 4
        mov long ptr esp, long 1
        call _vm_info@BGI
        mov edi, dd ptr ebp+8
        mov long ptr edi, long ptr esp+4
        leave 8
        retp 0

Runable_ByteCodeSize@BID endp


Runable_Title@BIE proc

        enter 8
        mov long ptr esp, long 0
        lva st1, long ptr esp
        push st1
        enter 4
        mov long ptr esp, long 2
        call _vm_info@BGI
        mov dd ptr esp+8, long ptr esp+4
        enter 4
        mov dd ptr esp, dd 0
        mov dd ptr esp, dd ptr esp+12
        enter 4
        mov dd ptr esp, dd 0
        lva st2, dd ptr esp
        push st2
        push dd ptr esp+8
        call VirtualOf@BGF
        enter 4
        mov dd ptr esp, dd 0
        mov dd ptr esp, dd ptr esp+8
        enter 4
        ms dd ptr esp
        lva esi, dd ptr esp
        push esi
        push dd ptr esp+8
        call CharToStr@IB
        mov edi, dd ptr ebp+8
        movs dd ptr edi, dd ptr esp+4
        rs dd ptr esp+4
        leave 36
        retp 0

Runable_Title@BIE endp


Runable_DLL_Count@BIF proc

        enter 4
        mov long ptr esp, long 0
        lva st1, long ptr esp
        push st1
        enter 4
        mov long ptr esp, long 3
        call _vm_info@BGI
        mov st2, dd ptr ebp+8
        mov long ptr st2, long ptr esp+4
        leave 8
        retp 0

Runable_DLL_Count@BIF endp


Runable_DLL_Proc_Count@BIG proc

        enter 4
        mov long ptr esp, long 0
        lva esi, long ptr esp
        push esi
        enter 4
        mov long ptr esp, long 4
        call _vm_info@BGI
        mov edi, dd ptr ebp+8
        mov long ptr edi, long ptr esp+4
        leave 8
        retp 0

Runable_DLL_Proc_Count@BIG endp


Runable_StackSize@BIH proc

        enter 4
        mov long ptr esp, long 0
        lva st1, long ptr esp
        push st1
        enter 4
        mov long ptr esp, long 5
        call _vm_info@BGI
        mov st2, dd ptr ebp+8
        mov long ptr st2, long ptr esp+4
        leave 8
        retp 0

Runable_StackSize@BIH endp


Runable_StackSpace@BII proc

        enter 4
        mov long ptr esp, long 0
        lva esi, long ptr esp
        push esi
        enter 4
        mov long ptr esp, long 6
        call _vm_info@BGI
        mov edi, dd ptr ebp+8
        mov long ptr edi, long ptr esp+4
        leave 8
        retp 0

Runable_StackSpace@BII endp


Runable_OnError@BHC proc

        enter 4
        mov dd ptr esp, dd 0
        mov st1, dd ptr ebp+8
        mov dd ptr esp, dd ptr st1
        push dd ptr esp
        enter 4
        mov long ptr esp, long 0
        call set_sys_event@BGJ
        leave 4
        retp 4

Runable_OnError@BHC endp


Runable_OnError@BHD proc

        enter 4
        mov dd ptr esp, dd 0
        lva st2, dd ptr esp
        push st2
        enter 4
        mov long ptr esp, long 0
        call get_sys_event@BHA
        mov esi, dd ptr ebp+8
        mov dd ptr esi, dd ptr esp+4
        leave 8
        retp 0

Runable_OnError@BHD endp


InitLibrary_System_basBJC proc

        retp 0

InitLibrary_System_basBJC endp


ReleaseLibrary_System_basBJD proc

        retp 0

ReleaseLibrary_System_basBJD endp

        exit
code_ ends
