'*
'* Button Class
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.CheckBox

$document "../../../doc/CheckBox.htm"

import windows.gui.CustomButton

published class CheckBox: implements CustomButton

      sub CheckBox ( byref Widget as Widget )

      sub Initialize ()
          this.Caption = "CheckBox"
      end sub

      virtual function Value () as string
              return = str ( this.Checked )
      end function

      virtual sub SetupValue ( byval m_Value as string )
              this.Checked = val ( m_Value )
      end sub

end class

sub CheckBox.CheckBox ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Button", WS_CHILD or BS_AUTOCHECKBOX or BS_CHECKBOX or WS_TABSTOP , 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()

end sub

sub InitLibrary

    RegisterClass ( "CheckBox", subptrclass ( CheckBox, CheckBox ) )

end sub
