'*
'* ColorDialog Class
'*
'* Copyright(c) by Metlashevskiy Egor <br>
'*
'*   
'*
'*
unit windows.gui.ColorDialog

$document "../../../doc/ColorDialog.htm"

import windows.gui.Control
import windows.gui.Widget


published class ColorDialog: implements Control
private:

public:
      dim Settings as CHOOSECOLOR
      dim m_Color as Color = 0

published:

      ' 
      property Color as Color

public:
      ' 
      declare function Show () as boolean
      '
      sub ColorDialog ( byref Control as Control )

end class

sub ColorDialog.Color ( byref m_Color as Color )
   this.m_Color = m_Color
end sub

function ColorDialog.Color () as Color
   return = this.m_Color
end function

function ColorDialog.Show () as boolean

  memset ( ref this.settings, 0, sizeof (CHOOSECOLOR) )

  with this.settings
    'set the structure size
    .lStructSize = sizeof(CHOOSECOLOR)
    'Set the owner
    dim byref w as Widget
    set w = this.GetParentClass

    if ref w <> null then
    if w.IsImplement ("Widget") then
    .hwndOwner = w.hwnd
    end if
    end if

    'set the application's instance
    .hInstance = GetModuleHandle (0)
    'no extra flags
    .flags = 0


    dim a as AnsiString ("")

    .lpCustColors = AddressOf ( a.Data )


    'Show the 'Select Color'-dialog
    return = CHOOSECOLOR(this.settings)
    If return <> 0 Then

        this.m_color = this.settings.rgbResult
    Else
        return = -1
    End If

end function


sub ColorDialog.ColorDialog ( byref Control as Control )
    this.ParentControl = Control
end sub

sub InitLibrary

    RegisterClass ( "ColorDialog", subptrclass ( ColorDialog, ColorDialog ) )

end sub

