'*                                                    
'* CustomListBox Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.CustomListBox

$document "../../../doc/CustomListBox.htm"

import windows.gui.Widget

published class CustomListBox: implements Widget

public:

      '**
      '*     CustomListBox
      '*

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean)
      end sub


      '**
      '*    
      '*
      sub AddItem ( byval m_string as string )
          dim a as AnsiString (m_string)
          SendMessage ( this.hWnd, LB_ADDSTRING, 0, AddressOf(a.data))
      end sub

      '**
      '*  
      '*
      sub DeleteItem ( byval Index as integer )
          SendMessage ( this.hWnd, LB_DELETESTRING, Index, 0)
      end sub

      '**
      '*  -   
      '*
      function ListCount () as integer
          return = SendMessage ( this.hWnd, LB_GETCOUNT, 0, 0)
      end function

      '**
      '*   
      '*
      sub Clear ()

          dim i as integer, c as integer
          c = this.ListCount
          for i = 0 to c - 1
              this.DeleteItem (0)
          next

      end sub

      '**
      '*    
      '*
      function ListIndex () as integer
          return = SendMessage ( this.hWnd, LB_GETCURSEL, 0, 0)
      end function


      '* 頥 ப  ᮬ  ᯨ᪠
      function List ( byval Index as integer ) as string

          dim tl as integer
          tl = SendMessage ( this.hWnd, LB_GETTEXTLEN, Index, 0)
          if tl <> 0 then

             dim mem as pointer = malloc ( tl + 1 )
             SendMessage ( this.hWnd, LB_GETTEXT, Index, AddressOf ( mem ) )

             return = CharToStr ( mem )
             mfree ( mem )

          end if


      end function

published:

      property MultiSelect as boolean

public:

      sub CustomListBox ()

end class

sub CustomListBox.MultiSelect ( byref m_value as boolean )
    'if m_Value = true then
    '   this.AddWndStyle  ( LBS_MULTIPLESEL ) 
    'else
    '   this.RemoveWndStyle  ( LBS_MULTIPLESEL ) 
    'end if
end sub

function CustomListBox.MultiSelect () as boolean
    'return = this.IsWndStyle ( LBS_MULTIPLESEL )
end function

sub CustomListBox.CustomListBox ()

end sub




