'*                                                    
'* Label Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Label

$document "../../../doc/Label.htm"

import windows.gui.CustomLabel

published class Label: implements CustomLabel ()

      declare sub Initialize ()

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )

      end sub

      sub Label ( byref Widget as Widget )


end class

sub Label.Initialize ()
    this.Caption = "Label"
    this.Canvas.Brush.CreateSolidBrush (GetSysColor(COLOR_BTNFACE))
    this.Canvas.BackStyle = Transparent
end sub

sub Label.Label ( byref Widget as Widget )
    this.ParentControl = Widget
    'this.CreateControl ( "Static", WS_CHILD or WS_TABSTOP, 10, 10, 90, 30, Widget.hWnd )
    this.CreateWindow( WS_CHILD or WS_OVERLAPPED or WS_CLIPCHILDREN or CS_VREDRAW or CS_HREDRAW,  100,100,400,300, Widget.hWnd, null )
    this.Initialize()
end sub

sub InitLibrary

    RegisterClass ( "Label", subptrclass ( Label, Label ) )

end sub
