'*                                                    
'* MultiListBox -                                          
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.MultiListBox

$document "../../../doc/MultiListBox.htm"

import windows.gui.CustomListBox


published class MultiListBox: implements CustomListBox

      declare sub Initialize ()

      sub MultiListBox ( byref Widget as Widget )

      declare function ItemSelected ( byval Index as integer ) as integer 
      declare function GetSelCount () as integer

end class

sub MultiListBox.Initialize ()
    this.Caption = "MultiListBox"
    this.BorderStyle = bsSingle
end sub


sub MultiListBox.MultiListBox ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "ListBox", WS_CHILD or WS_TABSTOP or WS_VSCROLL or LBS_NOTIFY _
                                    or LBS_MULTIPLESEL or LBS_EXTENDEDSEL or LBS_WANTKEYBOARDINPUT or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub


function MultiListBox.GetSelCount () as integer
    return = SendMessage ( this.hWnd, LB_GETSELCOUNT, 0, 0)
end function

function MultiListBox.ItemSelected ( byval Index as integer ) as integer 
    
     dim sc as integer
     dim byref Ri as integer
     dim byref p as pointer
     sc = this.GetSelCount()
     set p = malloc ((sc * 4))
     SendMessage ( this.hWnd, LB_GETSELITEMS, sc, AddressOf(ref p))
     set Ri = (ref p) + (Index* 4)
     return = RI
     mfree (p)

end function

sub InitLibrary

    RegisterClass ( "MultiListBox", subptrclass ( MultiListBox, MultiListBox ) )

end sub
