'*                                                    
'* Static Class                                         
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Static

$document "../../../doc/Static.htm"

import windows.gui.Control

published class Static: implements Widget ()

      declare sub Initialize ()

      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )

          if (message = WM_PAINT) or (message = WM_SIZE) then
               dim w as integer = this.Width
               dim h as integer = this.Height

               if this.IsDesigning then
                  dim m1 as integer = this.Canvas.Brush.Style
                  this.Canvas.Brush.Style = BS_NULL
                  this.Canvas.Pen.Style = PS_DOT
                  this.Canvas.Pen.Color = 0xAAAAAA
                  this.Canvas.Rectangle (0,0,w,h)
                  this.Canvas.Brush.Style = m1
               end if
          end if


      end sub

      sub Static ( byref Widget as Widget )

      virtual function Value () as string
              return = this.Caption
      end function

      virtual sub SetupValue ( byval m_Value as string )
              this.Caption = m_Value
      end sub
end class

sub Static.Initialize ()
    this.Caption = "Static"
end sub

sub Static.Static ( byref Widget as Widget )
    this.ParentControl = Widget
    this.CreateControl ( "Static", WS_CHILD or WS_TABSTOP, 10, 10, 90, 30, Widget.hWnd )
    this.Initialize()
end sub

sub InitLibrary

    RegisterClass ( "Static", subptrclass ( Static, Static ) )

end sub

