'*
'* Timer Class
'*
'* Copyright(c) by Metlashevskiy Egor
'*
unit windows.gui.Timer

$document "../../../doc/Timer.htm"

import windows.gui.Widget

published class Timer: implements Widget
private:
      dim m_timer as long = null
      dim m_interval as integer = 0

published:
      property Interval as integer
      event OnTimer ()

public:
      '**
      '*     Timer
      '*
      virtual sub WndProc ( byval hWnd as long, byval Message as long, byval WParam as long, byval LParam as long, byref Ret as boolean )
          select case Message
          case WM_TIMER: 
             this.OnTimer()
          end select
      end sub


      sub Timer ( byref Parent as Control )

end class

'default events
private sub Timer_OnTimer ( byref Timer as Widget ): end sub

sub Timer.Interval ( byref Interval as integer )
if (Interval <> m_interval) or (m_timer = null) then
  if m_timer <> null then
     KillTimer this.hWnd, 0
  end if
  SetTimer ( this.hWnd, 0, Interval, 0 )
  m_interval = Interval
end if
end sub

function Timer.Interval () as integer
    return = m_interval
end function

sub Timer.Timer ( byref Parent as Widget )
    this.ParentControl = Parent
    'this.hWnd = Parent.hWnd
    this.CreateControl ( "Button", WS_CHILD or BS_PUSHBUTTON or WS_TABSTOP , 10, 10, 90, 30, Parent.hWnd )
    'this.SHow
    this.OnTimer = subptr ( Timer_OnTimer )
    this.Name = "Timer"
    'SetTimer ( this.hWnd, 0, 1, 0 )
end sub


sub InitLibrary

    RegisterClass ( "Timer", subptrclasssub (Timer, Timer))

end sub



