'*
'* Copyright(c) 2004-2006 by Metlashevskiy Egor. All right reserved.
'*
'*   Windows.
'*
'*
unit windows.Message

' PeekMessage Options
const PM_NOREMOVE = &H0
const PM_REMOVE = &H1
const PM_NOYIELD = &H2

type POINTAPI
    x as long 
    y as long 
end type 

type Msg
    hWnd as long 
    message as long 
    wParam as long 
    lParam as long 
    time as long
    pt as POINTAPI
end type

declare function GetMessage lib "user32" alias "GetMessageA" (lpMsg as MSG, byval hwnd as long, byval wMsgFilterMin as long, byval wMsgFilterMax as long) as long 
declare function TranslateMessage lib "user32" alias "TranslateMessage" (lpMsg as MSG) as long
declare function DispatchMessage lib "user32" alias "DispatchMessageA" (lpMsg as MSG) as long 
declare function PeekMessage lib "user32" alias "PeekMessageA" (lpMsg as MSG, byval hwnd as long, byval wMsgFilterMin as long, byval wMsgFilterMax as long, byval wRemoveMsg as long) as long
declare function PostMessage lib "user32" alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
 