'*
'* DesignControl
'*
unit User.FormBuilder.DesignControl

import lang.*
import windows.gui.*

import User.FormBuilder.PropForm
import User.FormBuilder.MenuForm
import User.FormBuilder.Connector



declare sub Design_WndProc( byval hWnd as long, byval message as long, byval wParam as long, byval lParam as long, byref ret as boolean)

private px as integer = 0
private py as integer = 0
private ppos as POINTAPI
private curpos as POINTAPI
private curw as POINTAPI

private moves as boolean = false
private design_pa as pointer = null
private drag_type as integer = 0

public align_x as integer = 0
public align_y as integer = 0


public SelControl as pointer = null


function GetAlignX ( byval rx as integer ) as integer
    return = (floor(rx / align_x)) * align_x
end function

function GetAlignY ( byval ry as integer ) as integer
    return = (floor(ry / align_y)) * align_y
end function

sub GetNextNameForControl ( byref Container as Control, byval ForClass as string, byref Counter as integer )

       dim i as integer, c as integer
       dim byref ct as Control
       c = Container.GetControlCount ()
       if c > 0 then
       for i = 0 to c - 1
           set ct = Container.GetControl ( i )
           if ref ct <> null then
              if ct.ClassName = ForClass then Counter = Counter + 1
              GetNextNameForControl ( ct, ForClass, Counter )
           end if
       next
       end if

end sub

class DesignControl: implements Object

  public:

      dim Control as pointer = null
      dim Proc as pointer = null

      declare sub SetAction ( byref Widget as Widget )

      sub CreateControl ( byval ClassName as string, byref Parent as Widget )
          dim byref con as Widget
          set con = null

          'select case ClassName
          '    $include "CtrlInstance.inc"
          'end select

          dim byref Parc as Widget
          dim byref Curf as Widget
          set Curf = EditedForm
          set Parc = ref Parent
          set Parc = SelControl

          'if SelControl <> null then set Parc = SelControl

          if ref Parc <> null then
          set con = CreateControl (ClassName, Parc)
          if ref con <> null then
             'con.Show()
             dim Counter as integer = 0
             GetNextNameForControl ( Curf, con.ClassName, Counter )

             con.Visible = true
             con.Name = con.ClassName + str( Counter )
             con.Refresh
             this.SetAction ( con )
          end if

          else

             msgbox MSG_NOPARENT

          end if


      end sub


end class

sub DesignControl.SetAction ( byref Widget as Widget )
    if Widget.hWnd <> null then
       SetProp ( Widget.hWnd, "CustomWndProc", Widget::WndProc)
       Widget::WndProc = subptr (Design_WndProc)
       Widget.IsDesigning = true
    end if
end sub


sub DesignLoops

if moves = true then
if selcontrol <> null then

    dim pos as POINTAPI
    GetCursorPos ( pos )

    dim byref Widget as Widget
    set Widget = selcontrol

    if drag_type = 0 then

       Widget.Left = GetAlignX ( curpos.x + (pos.x - ppos.x) )
       Widget.Top = GetAlignY ( curpos.y + (pos.y - ppos.y) )

    end if

    if drag_type = 8 then

       dim cx as integer = pos.x - ppos.x
       dim cy as integer = pos.y - ppos.y

       Widget.Width = GetAlignX (curw.x + cx)
       Widget.Height = GetAlignY (curw.y + cy)



    end if


    'dim byref w as Widget
    'set w = EditedForm
    'w.refresh

end if
end if

end sub


public function ControlPicker ( Widget as Widget, X as integer, Y as integer) as pointer
dim ret as pointer = null
dim i as integer, c as integer

    c = Widget.GetControlCount ()

    'if widget.IsImplement ("Widget") then
    '       if (X > widget.Left) and (X < (widget.left+widget.width)) and (Y > widget.top) and ( Y < (widget.top + widget.height)) then
    '           ret = ref widget
    '       end if
    'end if

    if ret = null then
    if c > 0 then
       for i = 0 to c - 1
           dim byref w as Widget
           set w = Widget.GetControl (i)
           'print "CT", X, " ", Y, " ", w.ClassName, " ", r.Left, " ", r.Top, " ", r.Right," ",r.bottom, "\n"
           'print "D"
           if w.IsImplement ("Widget") then
            dim r as rect
            getwindowrect (w.hWnd, r)
           'print "CT", X, " ", Y, " ", w.ClassName, " ", r.Left, " ", r.Top, " ", r.Right," ",r.bottom, "\n"
           if (X > r.Left) and (X < (r.Right)) and (Y > r.top) and ( Y < (r.bottom)) then
               'print "FIND!"
               ret = ref w
           end if
           end if
           'if ret = null then
              re = ControlPicker (w,X,Y)
              if re <> null then ret = re
           'end if
       next
    end if
    end if


    return = ret

end function


public sub Design_WndProc( byval hWnd as long, byval message as long, byval wParam as long, byval lParam as long, byref Ret as boolean)
ret=false
dim wcPtr as pointer = GetProp ( hWnd, "WidgetClassPtr" )
dim cWnd as pointer = GetProp ( hWnd, "CustomWndProc" )
dim byref Widget as Widget
set Widget = wcptr
dim act as integer = 0
dim rb as boolean = false


    if wcPtr <> null then

       if cWnd <> null then
         dim mem as pointer = Widget::WndProc
         Widget::WndProc = cWnd
         Widget.WndProc ( hwnd, message, wparam, lparam, ret )
         Widget::WndProc = mem
      end if

    end if

    select case message
        case WM_LBUTTONUP:
         act = 1
        case WM_RBUTTONUP:
         act = 1
        case WM_MBUTTONUP:
         act = 1
    end select

    if (message = WM_LBUTTONDOWN) or (message = WM_RBUTTONDOWN) or (message = WM_MBUTTONDOWN) or (message = WM_LBUTTONDBLCLK) or (message = WM_RBUTTONDBLCLK) then

       act = 2
       'dim byref pf as PropForm
       'set pf = inspector
       'pf.Insp.ControlRef = ref Widget

       if (message = WM_RBUTTONDOWN)  then rb = true

    end if




    dim go as boolean = true

    if act = 0 then
    else
       go = false
    
       if act = 2 then
          GetCursorPos (ppos)

          moves = true
          SelControl = ref Widget

          dim r as RECT
          GetWindowRect (Widget.hWnd, r)

          'SelControl = 

          dim byref pf as PropForm
          set pf = inspector
          'SelControl = ControlPicker (Widget, ppos.x - r.left, ppos.y - r.top)

          'if EditedForm <> null then
          '   dim clientRect
          '   dim byref edtf as Widget
          '   set edtf = EditedForm
          '   SelControl = edtf.GetControlByhWnd ( WindowFromPoint (ppos.x, ppos.y) )
          '   print "SC", WindowFromPoint (ppos.x, ppos.y), " " , "\n"
          'end if

          pf.Insp.ControlRef = SelControl
          pf.RefreshEvents()

          'print SelControl

          curpos.x = Widget.Left
          curpos.y = Widget.Top
          curw.x = Widget.Width
          curw.y = Widget.Height

          if rb then
          drag_type = 8
          else
          drag_type = 0
          end if
       end if

       if act = 1 then
          moves = false
       end if
    
    end if

    if go = false then
       ret = true
    end if 
End sub

public sub Design_WndProcForm( byval hWnd as long, byval message as long, byval wParam as long, byval lParam as long, byref Ret as boolean)
dim wcPtr as pointer = GetProp ( hWnd, "WidgetClassPtr" )
dim byref Widget as Widget
set Widget = wcptr
dim act as integer = 0
dim rb as boolean = false


    if (message = WM_KEYDOWN) then
        if wparam = 46 then

        if SelControl <> null then

           dim byref sc as Widget
           set sc = SelControl

           if sc.isImplement ("Form") = false then
           if sc.hWnd <> hWnd then
           delete sc
           SelControl = null
           end if
           end if

        end if

        end if

    end if

    select case message
        case WM_CLOSE:

             ret = true
             'msgbox "f"  

        case WM_LBUTTONUP:
         act = 1
        case WM_RBUTTONUP:
         act = 1
        case WM_MBUTTONUP:
         act = 1
    end select

       if act = 1 then
          moves = false
       end if

    if (message = WM_LBUTTONDOWN) or (message = WM_RBUTTONDOWN) or (message = WM_MBUTTONDOWN) then
       if (message = WM_RBUTTONDOWN)  then rb = true

       act = 2
       GetCursorPos (ppos)
       dim byref pf as PropForm
       set pf = inspector
       SelControl = ref Widget
       EditedForm = ref Widget
          if EditedForm <> null then
             dim byref edtf as Widget
             set edtf = EditedForm
             'SelControl = edtf.GetControlByhWnd ( WindowFromPoint (ppos.x, ppos.y) )
             'dim r as rect
             'getwindowrect (edtf.hWnd, r)
             dim scc as pointer = 0
             scc = ControlPicker (edtf, ppos.x, ppos.y)
             if scc <> null then 

                SelControl = scc
                moves = true

                dim byref cc as Widget
                set cc = SelControl
                curpos.x = cc.Left
                curpos.y = cc.Top
                curw.x = cc.Width
                curw.y = cc.Height
            
                if rb then
                 drag_type = 8
                else
                 drag_type = 0
                end if

             end if
          end if
          pf.Insp.ControlRef = SelControl
          pf.RefreshEvents()
    end if



    dim go as boolean = true

    if act = 0 then
    else
       go = false    
    end if

    if go = false then
       ret = true
    end if 
End sub


sub InitLibrary
end sub

sub ReleaseLibrary

end sub